## mythtv 36.0+fixes.20260210.a312d68f

=== CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

#
# Set minimum required cmake version
#
# ~~~
# Supported CMake versions (as of 2023-10-25):
#   Ubuntu 20.04: 3.16.3 (not a target, 22.04 has 3.22.1)
#   Debian 11:    3.18.4 (12 has 3.25.1)
#   Centos 8/9:   3.20.2
#   RHEL 8/9:     3.20.2
#   SuSE 15.4:    3.20.4
#   Others:       3.22 or better
#
# Can use cmake features introduced in 3.16.
#
# Presets were introduced in 3.19 and would be helpful for wrangling
# compiler options.  3.19 also allows spaces in the names of tests.
# ~~~
cmake_minimum_required(VERSION 3.20)

#
# Where to find additional modules
#
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Require the C++17 standard, and allow compiler extensions.
#
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

#
# Set CMake features
#
include(SetCmakePolicies NO_POLICY_SCOPE)

#
# Determine which cmake variables came from the command line.
#
# This MUST be done before the call to 'project'.
#
get_cmake_property(vars CACHE_VARIABLES)
foreach(var IN LISTS vars)
  get_property(
    currentHelpString
    CACHE "${var}"
    PROPERTY HELPSTRING)
  if("${currentHelpString}" MATCHES
     "No help, variable specified on the command line.")
    list(APPEND CMDLINE_ARGS "-D${var}=${${var}}")
    # message("${var} = [${${var}}]  --  ${currentHelpString}")
  endif()
endforeach()

# Collapse all the various ways of specifying an android build down into a
# single flag.
if(ARM64
   OR SDK
   OR CMAKE_ANDROID_ARCH_ABI)
  set(ANDROID ON)
endif()

#
# Copied from cmake/Modules/CMakeGenericSystem.cmake.  That module isn't
# included on windows builds, and we need this variable set properly.
#
if(NOT DEFINED CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT 1)
endif()

#
# Read user options (part 1).  On android, several of these options affect the
# initialization performed by the project function.
#
message(STATUS "Including default MythTV options")
include(MythOptions)
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES1}")
include(${MYTH_USER_OVERRIDES1} OPTIONAL)

#
# Initial platform customization before declaring project. (CMAKE_CROSSCOMPILING
# isn't set yet. Nor is ANDROID or WIN32. The former is set by the call to
# project, and the latter two are set by the next two includes.)
#
include(platform/AndroidCrossEarlyInitialization)
include(platform/WindowsCrossEarlyInitialization)

#
# Declare the superbuild.
#
# This is where the all the android toolchain bits get pulled in.
#
project(
  MythTV-SuperBuild
  VERSION 36.0.0
  DESCRIPTION
    "MythTV is a Free Open Source software digital video recorder (DVR) project."
  HOMEPAGE_URL https://www.mythtv.org
  LANGUAGES C CXX)
include(VersionInformation)

message(
  STATUS "Building on ${CMAKE_HOST_SYSTEM_PROCESSOR} ${CMAKE_HOST_SYSTEM_NAME}")
message(STATUS "Building for ${CMAKE_SYSTEM_PROCESSOR} ${CMAKE_SYSTEM_NAME}")

# Get the mythtv default install path
if(CMAKE_CROSSCOMPILING)
  set(_CROSS "Cross")
endif()
include(platform/${CMAKE_SYSTEM_NAME}${_CROSS}DefaultPrefix OPTIONAL)

#
# Read user options (part 2)
#
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES2}")
include(${MYTH_USER_OVERRIDES2} OPTIONAL)

#
# Validate build system and build location.
#
include(platform/${CMAKE_SYSTEM_NAME}${_CROSS}ValidateBuildSystem OPTIONAL)
if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
  message(FATAL_ERROR "You may not compile in the source directory.")
endif()
if(NOT TARBALL_DIR)
  set(TARBALL_DIR "${PROJECT_SOURCE_DIR}/tarballs")
endif()
if(NOT JAVA_HOME)
  # Java home hasn't already been set by one of the platform build system
  # validations.
  #
  # (Have to put an environment variable in real variable to test it.)
  set(_TMP_ENV $ENV{JAVA_HOME})
  if(_TMP_ENV)
    message(STATUS "Using java from environment: ${_TMP_ENV}")
    set(JAVA_HOME ${_TMP_ENV})
  elseif(MYTH_JAVA_HOME)
    message(STATUS "Using java from options: ${MYTH_JAVA_HOME}")
    set(JAVA_HOME ${MYTH_JAVA_HOME})
  else()
    message(STATUS "Using java from system path")
  endif()
endif()

#
# FFmpeg doesn't support compiling out-of-tree after compiling in-tree. Catch
# this early and print an error message.
#
if(EXISTS ${PROJECT_SOURCE_DIR}/mythtv/external/FFmpeg/config.h)
  message(
    FATAL_ERROR
      "Detecting build artifacts in the source tree. You must clean the source directory before running cmake."
  )
endif()

#
# If the user didn't specify CMAKE_INSTALL_PREFIX on the command line, use the
# mythtv or user default value.
#
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT MYTH_DEFAULT_PREFIX
                                                   STREQUAL "")
  set(CMAKE_INSTALL_PREFIX ${MYTH_DEFAULT_PREFIX})
endif()
if(NOT DEFINED CMAKE_INSTALL_PREFIX OR CMAKE_INSTALL_PREFIX STREQUAL "")
  message(FATAL_ERROR "The CMAKE_INSTALL_PREFIX variable is undefined.")
endif()
if(CMAKE_CROSSCOMPILING AND CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
  message(
    FATAL_ERROR "CMAKE_INSTALL_PREFIX is /usr/local while cross compiling.")
endif()

#
# If the user didn't specify LIBS_INSTALL_PREFIX on the command line, use the
# mythtv default value.
#
if(NOT DEFINED LIBS_INSTALL_PREFIX OR LIBS_INSTALL_PREFIX STREQUAL "")
  if(NOT MYTH_DEFAULT_LIBS_PREFIX STREQUAL "")
    set(LIBS_INSTALL_PREFIX ${MYTH_DEFAULT_LIBS_PREFIX})
  else()
    set(LIBS_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
  endif()
endif()

# Make sure these changes propagate to rebuilds.
set(CMAKE_INSTALL_PREFIX
    ${CMAKE_INSTALL_PREFIX}
    CACHE PATH "" FORCE)
set(LIBS_INSTALL_PREFIX
    ${LIBS_INSTALL_PREFIX}
    CACHE PATH "" FORCE)

#
# Inject code from cmake provided modules. GNUInstallDirs uses
# CMAKE_INSTALL_PREFIX so make sure that's set properly first.
#
include(ExternalProject)
include(FindPkgConfig)
include(GNUInstallDirs)
include(ProcessorCount)

#
# Inject code from mythtv provided modules
#
include(GetLinuxInfo)

#
# Test for required minimum compiler versions.
#
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0.0)
    message(FATAL_ERROR "GCC version 8 or better required.")
  endif()
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 11.0.0)
    message(FATAL_ERROR "Clang version 11 or better required.")
  endif()
else()
  message(FATAL_ERROR "Unknown compiler.")
endif()

#
# Extract the MythTV source version number (either from Git, or from a file if
# the source has been exported out of git.)
#
include(SourceVersion)
mythtv_find_source_version(MYTHTV_SOURCE_VERSION MYTHTV_SOURCE_VERSION_MAJOR
                           MYTHTV_SOURCE_BRANCH)
message(STATUS "MythTV Source Version: ${MYTHTV_SOURCE_VERSION}")
message(STATUS "MythTV Source Branch: ${MYTHTV_SOURCE_BRANCH}")
if(NOT ${PROJECT_VERSION_MAJOR} EQUAL ${MYTHTV_SOURCE_VERSION_MAJOR})
  message(
    FATAL_ERROR "Major version number mismatch (cmake:${PROJECT_VERSION_MAJOR},"
                " source:.${MYTHTV_SOURCE_VERSION_MAJOR})")
endif()

#
# Is the install directory read-only
#
include(ReadOnlyTests)
ensure_dir_writable("Install" ${CMAKE_INSTALL_PREFIX})

#
# Figure out the CPU count and parallel execution flags.  For a build of any
# given sub-project you can add "-- -j <n>" to the end of the build command to
# perform parallel builds.  This is an attempt to get the superbuild
# orchestration script to properly pass the parallel execution flags to all
# sub-builds.
#
ProcessorCount(CPU_COUNT)
if(NOT CPU_COUNT EQUAL 0)
  message(STATUS "This system has ${CPU_COUNT} CPU(s).")

  if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Try not to kill older Raspberry Pis
    execute_process(
      COMMAND cat /proc/device-tree/model
      OUTPUT_VARIABLE MODEL
      ERROR_QUIET)
    if(MODEL MATCHES "Raspberry Pi (.)")
      if(${CMAKE_MATCH_1} LESS 4)
        set(CPU_COUNT 2)
      endif()
    endif()

    # Building with ninja, 'cmake --build build -j <n>' works properly for cmake
    # based projects, but not for make based projects.  Use this variable to
    # pass the cpu count into make based projects.
    set(MAKE_JFLAG -j${CPU_COUNT})

    # Tell ninja that it can execute as many parallel compile jobs as there are
    # CPUs, but it can only execute one link job at a time. This is probably
    # only necessary for small memory systems, but set it for all systems. Make
    # this a cache variable so that the user can override it from the command
    # line.
    set(CMAKE_JOB_POOLS
        "compile=${CPU_COUNT};link=1"
        CACHE STRING "Job counts for builds using ninja.")

    # Tell ninja that it can execute as many parallel jobs as there are CPUs.
    set(CTEST_BUILD_FLAGS -j${CPU_COUNT})
    set(ctest_test_args ${ctest_test_args} PARALLEL_LEVEL ${CPU_COUNT})
  else()
    # Building with unix makefiles, 'cmake --build build -j <n>' works properly.
  endif()
endif()

#
# Setup default search path for pkg-config files.
#
include(SetSearchPaths)

#
# Perform host and platform specific customizations.  These use variables
# generated by the GNUInstallDirs module, and the SetSearchPath module.
#
message(STATUS
       "Include optional platform/${CMAKE_SYSTEM_NAME}${_CROSS}Customization.cmake")
include(platform/${CMAKE_SYSTEM_NAME}${_CROSS}Customization OPTIONAL)

include(UpdatePkgConfig)

#
# Find required commands.
#
find_program(MAKE_EXECUTABLE NAMES gmake make REQUIRED)
message(VERBOSE "Found make: ${MAKE_EXECUTABLE}")
if(CMAKE_GENERATOR STREQUAL "Ninja")
  find_program(NINJA_EXECUTABLE NAMES ninja REQUIRED)
  message(VERBOSE "Found ninja: ${NINJA_EXECUTABLE}")
endif()
find_program(PATCH_EXECUTABLE NAMES patch REQUIRED)
message(VERBOSE "Found patch: ${PATCH_EXECUTABLE}")
if(CMAKE_CROSSCOMPILING)
  find_program(MESON_EXECUTABLE NAMES meson REQUIRED)
  message(VERBOSE "Found meson: ${MESON_EXECUTABLE}")
  find_program(MESON_EXECUTABLE NAMES gperf REQUIRED)
  message(VERBOSE "Found gperf: ${GPERF_EXECUTABLE}")
  find_program(AUTOMAKE_EXECUTABLE NAMES automake)
  if(AUTOMAKE_EXECUTABLE)
    execute_process(
      COMMAND ${AUTOMAKE_EXECUTABLE} --version
      OUTPUT_VARIABLE _OUTPUT
      ERROR_QUIET)
    if(_OUTPUT MATCHES "([0-9]+\.[0-9]+)")
      set(AUTOMAKE_VERSION ${CMAKE_MATCH_1})
    endif()
  endif()
  message(VERBOSE "Found automake: ${AUTOMAKE_EXECUTABLE}, version ${AUTOMAKE_VERSION}")
endif()

#
# Check compiler and installed header files
#
include(CompilerCaching)
include(SetCompilerOptions)

#
# Build a set of *.pc files for this platform.
#
include(platform/${CMAKE_SYSTEM_NAME}${_CROSS}BuildPkgConfigFiles OPTIONAL)

#
# For the next set of includes, update the CMDLINE_ARGS variable to change the
# install prefix to LIBS.  This will make the external cmake based projects
# install into LIBS.  The original value will need to be restored after the libs
# are built.
#
list(REMOVE_DUPLICATES CMDLINE_ARGS)
list(REMOVE_DUPLICATES PLATFORM_ARGS)
set(CMDLINE_ARGS_LIBS ${CMDLINE_ARGS})
list(APPEND CMDLINE_ARGS_LIBS
     "-DCMAKE_INSTALL_PREFIX:PATH=${LIBS_INSTALL_PREFIX}")
list(APPEND CMDLINE_ARGS "-DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_INSTALL_PREFIX}"
     "-DLIBS_INSTALL_PREFIX:PATH=${LIBS_INSTALL_PREFIX}")

#
# Create targets for building subsets of the needed libraries.
#
add_custom_target(external_libs)
add_custom_target(embedded_libs)
if(ENABLE_STRICT_BUILD_ORDER)
  add_dependencies(embedded_libs external_libs)
endif()
add_custom_target(all_libs DEPENDS external_libs embedded_libs)
add_custom_target(libs DEPENDS all_libs)

#
# Find (or build) system libraries
#
if(CMAKE_CROSSCOMPILING)
  message(VERBOSE "Setting up sub-projects for the external dependencies.")
  # Build the dependencies that will be needed later to build MythTV.
  include(BuildExternalLibraries)
else()
  # Validate the dependencies that will be needed later to build MythTV itself.
  # Adding checks here causes cmake to "fail early" while running cmake on the

=== Makefile ===
include config.mak

MAKE_SUBDIRS = external
QT_SUBDIRS   = libs html programs themes i18n locales

ifdef CONFIG_BINDINGS_PERL
    MAKE_SUBDIRS += bindings/perl
endif

ifdef CONFIG_BINDINGS_PYTHON
    MAKE_SUBDIRS += bindings/python
endif

ifdef CONFIG_BINDINGS_PHP
    MAKE_SUBDIRS += bindings/php
endif


SUBDIRS += $(MAKE_SUBDIRS) $(QT_SUBDIRS)

.PHONY: subdirs $(SUBDIRS)                        \
	clean     $(addsuffix _clean,    $(SUBDIRS))  \
	distclean $(addsuffix _distclean,$(SUBDIRS))  \
	install   $(addsuffix _install,  $(SUBDIRS))  \
	uninstall $(addsuffix _uninstall,$(SUBDIRS))  \
	global tags TAGS cleanold compdb \
	libs/libmythbase/version.h force

all: libs/libmythbase/version.h subdirs
tests: test
all_no_test: all
force:

config.mak:
	$(error run configure to create $@)

# Override PWD in case this is run from a makefile at a higher level with
# make -C mythtv
PWD := $(shell pwd)

libs/libmythbase/version.h:	version.sh force
	sh version.sh $(PWD)

# explicit subdir dependencies
libs: external
programs: libs


subdirs: $(SUBDIRS)

settings.pro: config.mak
%.pro: settings.pro

# explicit prerequisites for qmake generated makefiles
libs/Makefile: libs/libs.pro
html/Makefile: html/html.pro
programs/Makefile: programs/programs.pro
themes/Makefile: themes/themes.pro
i18n/Makefile: i18n/i18n.pro
locales/Makefile: locales/locales.pro

$(addsuffix /Makefile,$(QT_SUBDIRS)): %/Makefile :
	cd $*; $(QMAKE) QMAKE=$(QMAKE) -o $(@F) $(<F)

$(SUBDIRS): $(addsuffix /Makefile,$(SUBDIRS)) libs/libmythbase/version.h
	$(MAKE) -C $@

$(addsuffix _clean,$(SUBDIRS)): $(addsuffix /Makefile,$(SUBDIRS))
	$(MAKE) -C $(subst _clean,,$@) clean

$(addsuffix _distclean,$(SUBDIRS)): $(addsuffix /Makefile,$(SUBDIRS))
	$(MAKE) -C $(subst _distclean,,$@) distclean

$(addsuffix _install,$(SUBDIRS)): $(addsuffix /Makefile,$(SUBDIRS))
	$(MAKE) -C $(subst _install,,$@) install INSTALL_ROOT=${INSTALL_ROOT}

$(addsuffix _uninstall,$(SUBDIRS)): $(addsuffix /Makefile,$(SUBDIRS))
	$(MAKE) -C $(subst _uninstall,,$@) uninstall

clean: $(addsuffix _clean,$(SUBDIRS))

distclean: $(addsuffix _distclean,$(SUBDIRS))
	-rm -f libs/libmythbase/mythconfig.mak config.mak
	-rm -f libs/libmythbase/mythconfig.h
	-rm -f libs/libmythbase/version.h
	-rm -f external/FFmpeg/libavutil/avconfig.h
	-rm -f config.ep .qmake.stash
	-rm -f $(addsuffix /Makefile,$(QT_SUBDIRS))
	-rm -f ../GPATH ../GRTAGS ../GTAGS
	-rm -f ../TAGS ../tags

install: $(addsuffix _install,$(SUBDIRS))

uninstall: $(addsuffix _uninstall,$(SUBDIRS))
	-rmdir $(INSTALL_ROOT)/${PREFIX}/include/mythtv
	-rmdir $(INSTALL_ROOT)/${PREFIX}/lib/mythtv
	-rmdir $(INSTALL_ROOT)/${PREFIX}/share/mythtv

test: libs/libmythbase/version.h subdirs
	cd libs ; $(MAKE) test
	cd programs ; $(MAKE) test

SOURCES:=mythtv mythplugins platform themestringstool
ctags tags:
	@echo "Making tags..."
	@cd .. ; rm -f tags
	@cd .. ; find $(SOURCES) -name \*.h -o -name \*.c -o -name \*.cpp | grep -v moc_ | xargs -r ctags -a

etags TAGS:
	@echo "Making TAGS..."
	@cd .. ; rm -f TAGS
	@cd .. ; find ${SOURCES} -name \*.h -o -name \*.c -o -name \*.cpp | grep -v moc_ | xargs -r etags -a

global GPATH GRTAGS GTAGS:
	@echo "Making global tags..."
	@cd .. ; rm -f GPATH GRTAGS GTAGS
	@cd .. ; find ${SOURCES} -name \*.h -o -name \*.c -o -name \*.cpp | grep -v moc_ | gtags -f -

cleanall: clean
	@echo "Removing old moc and .o files missed by 'clean'..."
	@find .. -name moc_* -o -name *.o -name *.o.json | xargs -r rm

compdb:
	@echo "Building ../compile_commands.json"
	@programs/scripts/build_compdb.py

=== android/CMakeLists.txt ===
#
# Copyright (C) 2022-2024 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

if(CMAKE_ANDROID_ARCH_ABI)
  set(ANDROID ON)
endif()

# Can use cmake features introduced in 3.21.
cmake_minimum_required(VERSION 3.21)

#
# Validate parameters
#
foreach(_param IN ITEMS SUPER_VERSION MYTHTV_SOURCE_VERSION)
  if(${_param} STREQUAL "")
    message(FATAL_ERROR "${_param} is a required parameter")
  endif()
endforeach()

if(NOT DEFINED LIBS_INSTALL_PREFIX OR LIBS_INSTALL_PREFIX STREQUAL "")
  set(LIBS_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

#
# Where to find MythTV provided modules
#
# From the sources:
list(APPEND CMAKE_MODULE_PATH "${SUPER_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# From from earlier builds in the superbuild:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")

#
# Read user options (part 1).  On android, several of these options affect the
# initialization performed by the project function.
#
include(MythOptions)
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES1}")
include(${MYTH_USER_OVERRIDES1} OPTIONAL)

#
# Describe this project
#
project(
  mythfrontend
  VERSION ${SUPER_VERSION}
  LANGUAGES CXX)
include(VersionInformation)

#
# Read user options (part 2)
#
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES2}")
include(${MYTH_USER_OVERRIDES2} OPTIONAL)

#
# Inject code from cmake provided modules. GNUInstallDirs uses
# CMAKE_INSTALL_PREFIX so make sure that's set properly first.
#
include(GNUInstallDirs)
include(DumpAllVariables)

#
# Require the C++17 standard, and allow compiler extensions.
#
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

#
# Set search paths
#
include(SetSearchPaths)

#
# Perform platform specific customizations.
#
include(platform/AndroidCrossCustomization)

#
# The Qt androiddeployqt program reads the headers of shared object files and
# automatically includes any of their required dependencies. Add the Qt install
# directory to the CMAKE_FIND_ROOT_PATH list so that androiddeployqt can find
# the Qt libraries.
#
list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_INSTALL_PREFIX}/qt)
list(APPEND CMAKE_FIND_ROOT_PATH ${LIBS_INSTALL_PREFIX}/qt)

#
# androiddeployqt also searches for android-dependencies.xml files for each
# shared object file loaded.  These are normally installed in the lib directory,
# but androiddeployqt doesn't add that "/lib" when searching ROOT_PATHs.  Add
# "/lib" manually to CMAKE_FIND_ROOT_PATH so that androiddeployqt can find the
# mythtv dependency files.
#
list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_INSTALL_PREFIX}/lib)

#
# Clean up the CMAKE_FIND_ROOT_PATH list
#
list(REMOVE_DUPLICATES CMAKE_FIND_ROOT_PATH)

# Get tags used in bundle names.
include(${CMAKE_ANDROID_NDK}/build/cmake/abis.cmake)

#
# In Qt5, these variables that will be directly referenced by the code to build
# an apk.  In Qt6, these variables are set as properties on the executable and
# are referenced that way.
#
execute_process(
  COMMAND "date" "+%Y%m%d"
  OUTPUT_VARIABLE _date
  OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ERROR_IS_FATAL ANY)
set(_BUNDLE_NAME "${NDK_ABI_${CMAKE_ANDROID_ARCH_ABI}_ARCH}")

set(ANDROID_PACKAGE_SOURCE_DIR
    ${CMAKE_CURRENT_BINARY_DIR}/android-package-source)
set(ANDROID_VERSION_CODE 1)
set(ANDROID_VERSION_NAME
    "${_date}-qt${QT_VERSION_MAJOR}-${_BUNDLE_NAME}-${MYTHTV_SOURCE_VERSION}")
set(QT_ANDROID_APPLICATION_ARGUMENTS "-v general")

#
# Shorthand
#
set(MYTHTV_FULL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR}/mythtv)
set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/android-build)
set(ASSETS_DIR ${BUILD_DIR}/assets/mythtv)
set(JNI_DIR ${BUILD_DIR}/jni)
set(LIBS_ARCH ${BUILD_DIR}/libs/${CMAKE_ANDROID_ARCH_ABI})
set(QT_TEMPL_DIR ${LIBS_INSTALL_PREFIX}/qt/src/android/templates)

#
# Copy android-package-source into the build directory.  This allows Qt version
# specific customization.
#
file(COPY ${SUPER_SOURCE_DIR}/mythtv/android-package-source DESTINATION .)
if(ANDROID_TARGET_SDK_VERSION GREATER_EQUAL 31)
  list(APPEND MANIFEST_APPLICATION_ACTIVITY_EXTRAS android:exported="false")
endif()
if(ANDROID_TARGET_SDK_VERSION GREATER 99)
  list(APPEND MANIFEST_APPLICATION_EXTRAS android:examplsTagHere="false")
endif()
list(JOIN MANIFEST_APPLICATION_EXTRAS " " MANIFEST_APPLICATION_EXTRAS_STR)
list(JOIN MANIFEST_APPLICATION_ACTIVITY_EXTRAS " "
     MANIFEST_APPLICATION_ACTIVITY_EXTRAS_STR)
configure_file(AndroidManifest.xml.${QT_VERSION_MAJOR}.in
               android-package-source/AndroidManifest.xml @ONLY)
configure_file(${QT_TEMPL_DIR}/res/values/libs.xml
               android-package-source/res/values)
file(CHMOD android-package-source/res/values/libs.xml
     FILE_PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

#
# Create the directory structure needed for packaging.
#
file(MAKE_DIRECTORY ${ASSETS_DIR} ${JNI_DIR})

#
# Generate files
#
configure_file(jni/Android.mk.in ${JNI_DIR}/Android.mk COPYONLY)
configure_file(jni/Application.mk.in ${JNI_DIR}/Application.mk @ONLY)

#
# Copy necessary XML files into the android-build/assets directory.
#
set(_XML_FILES CDS_scpd.xml CMGR_scpd.xml MFEXML_scpd.xml MSRR_scpd.xml)
list(TRANSFORM _XML_FILES PREPEND ${MYTHTV_FULL_DATADIR}/)
file(COPY ${_XML_FILES} DESTINATION ${ASSETS_DIR})

#
# Copy the translations into the android-build/assets directory.
#
file(
  GLOB _translations
  LIST_DIRECTORIES FALSE
  ${MYTHTV_FULL_DATADIR}/i18n/mythfrontend*)
file(COPY ${_translations} DESTINATION ${ASSETS_DIR}/i18n)

#
# Copy the fonts, etc into the android-build/assets directory.
#
foreach(DIRNAME ${MYTHTV_FULL_DATADIR}/fonts ${MYTHTV_FULL_DATADIR}/locales
                ${MYTHTV_FULL_DATADIR}/metadata ${MYTHTV_FULL_DATADIR}/themes)
  if(EXISTS ${DIRNAME})
    file(COPY ${DIRNAME} DESTINATION ${ASSETS_DIR})
  endif()
endforeach()

#
# Create list of libraries for the android packaging code to copy
#

# Library needed by the Qt MySql plugin.
list(APPEND EXTRA_LIB_NAMES mariadb/libmariadb.so)

# Libraries needed by the MythTV plugins.
if(MYTH_BUILD_PLUGINS AND MYTH_BUILD_ANDROID_PLUGINS)
  # MythMusic
  list(
    APPEND
    EXTRA_LIB_NAMES
    libFLAC.so
    libogg.so
    libvorbis.so
    libvorbisenc.so
    libvorbisfile.so)
endif()

function(find_full_pathnames NAMES PATHS_OUT MISSING_OUT)
  # Possible locations for additional libraries.
  set(LIBDIRS
      ${CMAKE_INSTALL_PREFIX}/lib
      ${CMAKE_INSTALL_PREFIX}/lib/mythtv/plugins
      ${CMAKE_INSTALL_PREFIX}/lib64
      ${CMAKE_INSTALL_PREFIX}/lib64/mythtv/plugins
      ${LIBS_INSTALL_PREFIX}/lib
      ${LIBS_INSTALL_PREFIX}/lib64)
  list(REMOVE_DUPLICATES LIBDIRS)

  # Find the full pathname each of the libraries
  foreach(NAME IN LISTS ${NAMES})
    set(FOUND FALSE)
    foreach(LIBDIR IN LISTS LIBDIRS)
      if(EXISTS ${LIBDIR}/${NAME})
        list(APPEND PATHS ${LIBDIR}/${NAME})
        set(FOUND TRUE)
        break()
      endif()
    endforeach()
    if(NOT FOUND)
      list(APPEND MISSING ${NAME})
    endif()
  endforeach()

  set(${PATHS_OUT}
      ${PATHS}
      PARENT_SCOPE)
  set(${MISSING_OUT}
      ${MISSING}
      PARENT_SCOPE)
endfunction()

find_full_pathnames(EXTRA_LIB_NAMES ANDROID_EXTRA_LIBS MISSING)
if(MISSING)
  message(FATAL_ERROR "Can't find the following libraries: ${MISSING}")
endif()
list(SORT ANDROID_EXTRA_LIBS)

#
# Find and add the MythTV plugins to the list of shared objects.
#
if(MYTH_BUILD_PLUGINS AND MYTH_BUILD_ANDROID_PLUGINS)
  set(PLUGIN_NAMES
      # MythTV plugins
      libmythpluginmytharchive.so
      libmythpluginmythbrowser.so
      libmythpluginmythgame.so
      libmythpluginmythmusic.so
      libmythpluginmythnetvision.so
      libmythpluginmythnews.so
      libmythpluginmythzoneminder.so)
  find_full_pathnames(PLUGIN_NAMES PLUGINS_FOUND MISSING)
  list(APPEND ANDROID_EXTRA_LIBS ${PLUGINS_FOUND})
endif()

if(QT_VERSION_MAJOR EQUAL 5)
  # IMPORTANT: All the variables necessary to describe the APK must be set
  # before this include.  The android_deployment_settings.json file will be
  # generated during this include process.
  include(MythFindQt)

  #
  # Install the mythfrontend application
  #
  foreach(_app IN ITEMS mythfrontend)
    execute_process(
      COMMAND
        ${CMAKE_COMMAND} -E copy_if_different
        ${CMAKE_INSTALL_PREFIX}/bin/${_app}
        ${LIBS_ARCH}/lib${_app}_${CMAKE_ANDROID_ARCH_ABI}.so
        COMMAND_ERROR_IS_FATAL ANY)
  endforeach()

  #
  # Codesigning in Qt5 is done by adding arguments to the command line.
  #
  if(QT_ANDROID_SIGN_APK)
    set(BUNDLESIGN
        "--sign" ${QT_ANDROID_KEYSTORE_PATH} ${QT_ANDROID_KEYSTORE_ALIAS}
        "--storepass" ${QT_ANDROID_KEYSTORE_STORE_PASS})
  endif()

  #
  # This is a copy of the apk target from Qt5AndroidSupport.cmake.  It is here
  # to ensure that the JAVA_HOME environment variable is always set to the value
  # configured in these cmake file.  Otherwise the call to 'cmake --build
  # <builddir>' will attempt to use whatever is present (if anything) in the
  # invoker's environment.
  #
  add_custom_target(
    apk2
    COMMAND
      # cmake-format: off
      echo ${CMAKE_COMMAND} -E env JAVA_HOME=${JAVA_HOME}
        ${ANDROID_DEPLOY_QT}
        --input "${PROJECT_BINARY_DIR}/android_deployment_settings.json"
        --output "${PROJECT_BINARY_DIR}/android-build"
        --apk "${PROJECT_BINARY_DIR}/android-build/${PROJECT_NAME}.apk"
        --android-platform ${ANDROID_PLATFORM}
        ${BUNDLESIGN}
        --verbose
      # cmake-format: on
    COMMAND
      # cmake-format: off
      ${CMAKE_COMMAND} -E env JAVA_HOME=${JAVA_HOME}
        ${ANDROID_DEPLOY_QT}
        --input "${PROJECT_BINARY_DIR}/android_deployment_settings.json"
        --output "${PROJECT_BINARY_DIR}/android-build"
        --apk "${PROJECT_BINARY_DIR}/android-build/${PROJECT_NAME}.apk"
        --android-platform ${ANDROID_PLATFORM}
        ${BUNDLESIGN}
        --verbose
      # cmake-format: on
    DEPENDS ${ANDROID_EXTRA_LIBS}
    VERBATIM USES_TERMINAL)

  #
  # Force the apk to always be built
  #
  # By using these two targets, the apk isn't rebuilt at the install stage.
  add_custom_target(
    apktest1
    DEPENDS apk2
    COMMAND echo
    BYPRODUCTS "${PROJECT_BINARY_DIR}/android-build/${PROJECT_NAME}.apk")
  add_custom_target(
    apktest2 ALL
    DEPENDS "${PROJECT_BINARY_DIR}/android-build/${PROJECT_NAME}.apk")

  #
  # Set variables use by Qt5Core/Qt5AndroidSupport.cmake when creating the file
  # android_deployment_settings.json.
  #
  # These variables aren't currently set to anything:
  # ~~~
  #  ANDROID_DEPLOYMENT_DEPENDENCIES
  #  ANDROID_EXTRA_PLUGINS
  #  QML_IMPORT_PATH
  # ~~~
  #

elseif(QT_VERSION_MAJOR EQUAL 6)
  set(QT_ANDROID_PLATFORM ${ANDROID_PLATFORM})
  set(QT_ENABLE_VERBOSE_DEPLOYMENT ON)

  # Inject code from super-project provided modules (part 2). All the variables
  # necessary to describe the APK must be set before this include.
  #
  # IMPORTANT: The android_deployment_settings.json file is *NOT* generated with
  # this include.  It is generated by the call to qt_add_executable.
  include(MythFindQt)

  set(CMAKE_BUILD_TYPE Debug)
  if(QT_KNOWN_POLICY_QTP0001)
    qt_policy(SET QTP0001 NEW)
  endif()
  if(QT_KNOWN_POLICY_QTP0002)
    qt_policy(SET QTP0002 NEW)
  endif()
  if(QT_KNOWN_POLICY_QTP0003)
    qt_policy(SET QTP0003 NEW)
  endif()

  #
  # Create a dummy mythfrontend executable.  This is where all the magic happens
  # behind the scenes in Qt6 to build an APK.
  #
  qt_add_executable(mythfrontend dummy.cpp)
  set_source_files_properties(dummy.cpp PROPERTIES HEADER_FILE_ONLY ON)

  #
  # Overwrite the dummy mythfrontend application with the real application.
  #
  add_custom_command(
    TARGET mythfrontend
    POST_BUILD
    COMMAND
      ${CMAKE_COMMAND} -E copy_if_different
      ${CMAKE_INSTALL_PREFIX}/bin/mythfrontend
      libmythfrontend_${CMAKE_ANDROID_ARCH_ABI}.so)

=== darwin/CMakeLists.txt ===
#
# Copyright (C) 2022-2024 David Hampton and John Hoyt
#
# See the file LICENSE_FSF for licensing information.
#

set(APP_NAME mythfrontend)
set(APP_EXE_NAME ${APP_NAME})
set(APP_EXES ${APP_NAME} mythpreviewgen mythutil mythmetadatalookup)

# Can use cmake features introduced in 3.21.
cmake_minimum_required(VERSION 3.21)

#
# Validate parameters
#
foreach(_param IN ITEMS SUPER_VERSION MYTHTV_SOURCE_VERSION)
  if(${_param} STREQUAL "")
    message(FATAL_ERROR "${_param} is a required parameter")
  endif()
endforeach()

if(NOT DEFINED LIBS_INSTALL_PREFIX OR LIBS_INSTALL_PREFIX STREQUAL "")
  set(LIBS_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

#
# Where to find MythTV provided modules
#
# From the sources:
list(APPEND CMAKE_MODULE_PATH "${SUPER_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# From earlier builds in the superbuild:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")

#
# Read user options (part 1).  On macOS, several of these options affect the
# initialization performed by the project function.
#
include(MythOptions)
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES1}")
include(${MYTH_USER_OVERRIDES1} OPTIONAL)

#
# Describe this project
#
project(
  ${APP_NAME}
  VERSION ${SUPER_VERSION}
  LANGUAGES CXX)
include(VersionInformation)

#
# Read user options (part 2)
#
message(STATUS "Including user overrides ${MYTH_USER_OVERRIDES2}")
include(${MYTH_USER_OVERRIDES2} OPTIONAL)

#
# Inject code from cmake provided modules. GNUInstallDirs uses
# CMAKE_INSTALL_PREFIX so make sure that's set properly first.
#
include(GNUInstallDirs)
include(DumpAllVariables)

#
# Require the C++17 standard, and allow compiler extensions.
#
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

#
# Set search paths
#
include(SetSearchPaths)

#
# Perform platform specific customization
#
include(platform/DarwinCustomization)

#
# The Qt macdeployqt program reads the headers of shared object files and
# automatically includes any of their required dependencies. Add the Qt install
# directory to the CMAKE_FIND_ROOT_PATH list so that macdeployqt can find
# the Qt libraries.
#
list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_INSTALL_PREFIX}/qt)
list(APPEND CMAKE_FIND_ROOT_PATH ${LIBS_INSTALL_PREFIX}/qt)

#
# macdeployqt needs some help to find the installed mythtv libraries
#
list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_INSTALL_PREFIX}/lib)

#
# Clean up the CMAKE_FIND_ROOT_PATH list
#
list(REMOVE_DUPLICATES CMAKE_FIND_ROOT_PATH)

#
# Set any package manger specific variables
#
if(MACPORTS)
  set(PKGMGR_PREFIX "${MACPORTS_PREFIX}")
  set(PKGMGR_LIB_DIR "${MACPORTS_PREFIX}/lib")
  set(FONT_PATH "${MACPORTS_PREFIX}/share/fonts")
elseif(HOMEBREW)
  set(PKGMGR_PREFIX "${HOMEBREW_PREFIX}")
  set(PKGMGR_LIB_DIR "${HOMEBREW_PREFIX}/lib")
  set(FONT_PATH "$ENV{HOME}/Library/fonts")
endif()

#
# Shorthand
#
set(MYTHTV_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(MYTHTV_FULL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR}/mythtv)
set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(BUILD_APP ${BUILD_DIR}/${APP_NAME}.app)
set(CONTENTS_DIR ${BUILD_DIR}/${APP_NAME}.app/Contents)
set(MACOS_DIR ${CONTENTS_DIR}/MacOS)
set(RSRC_DIR ${CONTENTS_DIR}/Resources)
set(RSRC_MYTHLIB_DIR ${CONTENTS_DIR}/Resources/lib/mythtv)
set(RSRC_MYTHBIN_DIR ${CONTENTS_DIR}/Resources/bin/)
set(FMWK_DIR ${CONTENTS_DIR}/Frameworks)
set(PLUGINS_DIR ${CONTENTS_DIR}/PlugIns)
set(PLIST_FILE ${CONTENTS_DIR}/Info.plist)

# qt 6.9.0 on homebrew moved the plugins and qml directories
# into share.  This might also occur in macports later so
# add logic to detect the move
set(QT_PLUGINS_DIR "${_QT_BASE}/plugins/")
if(NOT EXISTS "${QT_PLUGINS_DIR}")
  set(QT_PLUGINS_DIR "${_QT_BASE}/share/qt/plugins/")
endif()
set(QT_QML_DIR "${_QT_BASE}/qml/")
if(NOT EXISTS "${QT_QML_DIR}")
  set(QT_QML_DIR "${_QT_BASE}/share/qt/qml/")
endif()

# Locate Python for embedding the correct version from build time
#
message(STATUS "Setting up Python environment and variables")
find_package(Python3 COMPONENTS Interpreter Development)

# Find the actual python framework not the symlink or the location of any
# python virtual environments
if(DEFINED ENV{VIRTUAL_ENV} AND NOT $ENV{VIRTUAL_ENV} STREQUAL "")
  # If using a Virtual Environment, Python3_ROOT_DIR points to the virtual
  # environment so use _Python3_PATH2 instead
  execute_process(
    COMMAND zsh -c "greadlink -f ${_Python3_PATH2}"
      OUTPUT_VARIABLE PYTHON_ROOT_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  # This uses Python3_ROOT_DIR as it points to the real python framework whereas
  execute_process(
    COMMAND zsh -c "greadlink -f ${Python3_ROOT_DIR}"
      OUTPUT_VARIABLE PYTHON_ROOT_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

set(PYTHON_DOT_VERSION ${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR})
set(PYTHON_BASENAME python${PYTHON_DOT_VERSION})
set(PYTHON_MACOS_EXE ${MACOS_DIR}/${PYTHON_BASENAME})
set(PYTHON_FMWK_DIR ${FMWK_DIR}/Python.framework)
set(PYTHON_FMWK_ROOT ${PYTHON_FMWK_DIR}/Versions/${PYTHON_DOT_VERSION})
set(PYTHON_FMWK_LIB_DIR ${PYTHON_FMWK_ROOT}/lib)
set(PYTHON_FMWK_FULL_DYLIB ${PYTHON_FMWK_ROOT}/Python)
set(PYTHON_RSRC_LIB_DIR ${RSRC_DIR}/lib/${PYTHON_BASENAME})
set(PYTHON_SOURCE_EXE ${PYTHON_ROOT_DIR}/Resources/Python.app/Contents/MacOS/Python)
set(PYTHON_SOURCE_DYLIB ${PYTHON_ROOT_DIR}/Python)

# Create a variable to correcting the path for the embedded python support libraries
if(DEFINED ENV{VIRTUAL_ENV} AND NOT $ENV{VIRTUAL_ENV} STREQUAL "")
  set(PYTHON_MYTHTV_SCRIPT_EXE $ENV{VIRTUAL_ENV}/bin/python3)
elseif(MACPORTS)
  set(PYTHON_MYTHTV_SCRIPT_EXE ${PKGMGR_PREFIX}/Library/Frameworks/Python.framework/Versions/${PYTHON_DOT_VERSION}/bin/python3)
elseif(HOMEBREW)
  set(PYTHON_MYTHTV_SCRIPT_EXE ${PKGMGR_PREFIX}/opt/python@${PYTHON_DOT_VERSION}/bin/python${PYTHON_DOT_VERSION})
endif()

#
# Activate the MacOS Bundling and set bundle version variables
#
message(STATUS "Setting up App Bundle structure and variables")
set(MACOSX_BUNDLE TRUE)
string(TIMESTAMP YEARSTAMP "%Y")
set(MACOSX_BUNDLE_BUNDLE_NAME ${APP_NAME})
set(MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2023-${YEARSTAMP} MythTV Dev Team")
set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.mythtv.${APP_NAME}")
set(MACOSX_BUNDLE_BUNDLE_GUI_IDENTIFIER "${MACOSX_BUNDLE_GUI_IDENTIFIER}")
set(MACOSX_BUNDLE_ICON_FILE "${APP_NAME}.icns")
set(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR})

#
# Create the directory structure needed for packaging.
#
file(MAKE_DIRECTORY ${BUILD_DIR} ${MACOS_DIR} ${FMWK_DIR} ${RSRC_DIR} ${RSRC_MYTHLIB_DIR} ${RSRC_MYTHBIN_DIR})
if(MYTH_BUILD_PLUGINS)
  file(MAKE_DIRECTORY ${PLUGINS_DIR} )
endif()
#
# Copy in support files that do not need to be linked via macdeployqt
# Start with the mythtv/share directory into the Resource directory.
#
message(STATUS "Copying in MythTV support files")
message(VERBOSE "  Copying 'share' directory")
file(COPY ${MYTHTV_FULL_DATADIR} DESTINATION ${RSRC_DIR}/share)

# Copy the perl support files into Resources/lib.
message(VERBOSE "  Copying perl files")
file(COPY ${MYTHTV_INSTALL_PREFIX}/lib/perl5 DESTINATION ${RSRC_DIR}/lib)

## Copy the python support files into Resources/lib.
# If using a Virtual Environment, all of the necessary site-packages should
# already have been into the install prefix as well
if(EXISTS ${MYTHTV_INSTALL_PREFIX}/lib/${PYTHON_BASENAME})
  message(VERBOSE "  Copying python files")
  file(COPY ${MYTHTV_INSTALL_PREFIX}/lib/${PYTHON_BASENAME} DESTINATION ${RSRC_DIR}/lib)
endif()

# Copy the application icon into the Resources directory.
message(VERBOSE "  Copying icons")
file(COPY ${APP_NAME}.icns DESTINATION ${RSRC_DIR})

# Copy the application startup script and mythsources into the Resources
# directory. The mythsources files defines any necessary application
# environmental variables and aliases.  Both need cmake to configure internal
# variables.
message(VERBOSE "  Copying startup script and python alias")
configure_file("${CMAKE_SOURCE_DIR}/startup_script.zsh.in" "${MACOS_DIR}/${APP_NAME}.zsh" @ONLY)

# Update the files in share (e.g. python shebang's) to point to internally to the App
# Run theses as separate commands in case one fails
message(VERBOSE "  Fixing python shebangs")
# This first case should find the correct paths set by the myth build process
execute_process(
  COMMAND zsh -c "LC_ALL=C find ${RSRC_DIR} -type f -exec sed -i '' \"s^${PYTHON_MYTHTV_SCRIPT_EXE}.*^${PYTHON_BASENAME}^g\" {} + ")
# this second case is a bit more brute force
execute_process(
  COMMAND zsh -c "LC_ALL=C find ${RSRC_DIR} -type f -exec sed -i '' \"s^#!.*/python3.*^#!${PYTHON_BASENAME}^g\" {} + ")
execute_process(
  COMMAND zsh -c "LC_ALL=C find ${RSRC_DIR} -type f -exec sed -i '' \"s^${MYTHTV_INSTALL_PREFIX}^../Resources^g\" {} + ")

message(VERBOSE "  Copying fonts")
# Find and copy in the Dejavu and liberation fonts
execute_process(
  COMMAND zsh -c "find ${FONT_PATH} -name \"Deja*.ttf\" -o -name \"Liberation*.ttf\""
  OUTPUT_VARIABLE FONT_LIST
  OUTPUT_STRIP_TRAILING_WHITESPACE)
string(REPLACE "\n" ";" FONT_LIST ${FONT_LIST})
foreach(FONT ${FONT_LIST})
    file(COPY ${FONT} DESTINATION ${RSRC_DIR}/share/mythtv/fonts)
endforeach()

# This function searches for the mythtv executable and library locations.
# The output is divided into rpath'd files and hard-linked files.
# These need different handling when conotpying into the app bundle
function(find_libraries_pathnames EXES_IN PATHS_OUT MISSING_OUT)
  # Possible locations for additional libraries.
  set(SRCHDIRS
      ${MYTHTV_INSTALL_PREFIX}/bin/
      ${MYTHTV_INSTALL_PREFIX}/lib/
      ${MYTHTV_INSTALL_PREFIX}/lib/mythtv/plugins/
      ${LIBS_INSTALL_PREFIX}/lib/
      ${PKGMGR_LIB_DIR})
  list(REMOVE_DUPLICATES SRCHDIRS)

  # Find the full path for each of the mythtv generated or rpath linked libraries
  foreach(EXENAME IN LISTS ${EXES_IN})
    # extract out all mythtv / rpath libraries from the NAME executable or dylib
    # use sed to cut out the text after the library name
    execute_process(
      COMMAND zsh -c "otool -L \"${MYTHTV_INSTALL_PREFIX}/bin/${EXENAME}\" |grep -e rpath -e \"${MYTHTV_INSTALL_PREFIX}\"| sed 's^\ (.*^^'"
      OUTPUT_VARIABLE OTOOL_OUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    # otool's outputs are separated with line breaks and a tab per library, so
    # we need to replace those with a delimiter to make it a list.
    string(REPLACE "@rpath/" "" OTOOL_OUT ${OTOOL_OUT})
    string(REPLACE "\n\t" ";" OTOOL_OUT ${OTOOL_OUT})
    # remove the executable from the list
    list(REMOVE_AT OTOOL_OUT 0)
    list(APPEND FILENAMES ${OTOOL_OUT})
  endforeach()
  list(REMOVE_DUPLICATES FILENAMES)
  foreach(NAME IN LISTS FILENAMES)
    # if the LIBNAME exists, this library is hard linked and does not need any
    # rpath search / handling
    if(EXISTS ${NAME})
      set(FOUND TRUE)
    # otherwise, this was an rpath library and needs to be located
    else()
      set(FOUND FALSE)
      foreach(SRCHDIR IN LISTS SRCHDIRS)
        if(EXISTS ${SRCHDIR}/${NAME})
          set(NAME ${SRCHDIR}/${NAME})
          set(FOUND TRUE)
          break()
        endif()
      endforeach()
    endif()
    if(NOT FOUND)
      list(APPEND MISSING ${NAME})
    endif()
    list(APPEND PATHS ${NAME})
  endforeach()
  set(${PATHS_OUT}
      ${PATHS}
      PARENT_SCOPE)
  set(${MISSING_OUT}
      ${MISSING}
      PARENT_SCOPE)
endfunction()

#
# create the dummy app bundle's target
#
if(QT_VERSION_MAJOR EQUAL 5)
  # IMPORTANT: All the variables necessary to describe the APP must be set
  # before this include.
  find_package(Qt5 COMPONENTS Core REQUIRED)
  get_target_property(qmake_executable Qt5::qmake IMPORTED_LOCATION)

=== html/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

# mythfrontend.html is just a copy of frontend_index.qsp

install(
  FILES
        favicon.ico
        mythbackend.html
        mythfrontend.html
        robots.txt
  DESTINATION ${CMAKE_INSTALL_DATADIR}/mythtv/html)

install(
  DIRECTORY 3rdParty
            apps
            assets
            images
            css
            xslt
  DESTINATION ${CMAKE_INSTALL_DATADIR}/mythtv/html)

=== libs/CMakeLists.txt ===
add_subdirectory(libmythbase)
if(TARGET mythtv_mheg)
  add_subdirectory(libmythfreemheg)
endif()
if(NOT CONFIG_LIBMPEG2EXTERNAL)
  add_subdirectory(libmythmpeg2)
endif()
add_subdirectory(libmythui)
add_subdirectory(libmythupnp)
add_subdirectory(libmyth)
add_subdirectory(libmythtv)
add_subdirectory(libmythmetadata)
add_subdirectory(libmythprotoserver)

=== bindings/perl/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

#
# This directory is only processed when USING_BINDINGS_PERL is set.
#
if(NOT USING_BINDINGS_PERL)
  return()
endif()

#
# Hide non-error output unless doing a verbose build.
#
if(NOT CMAKE_VERBOSE_MAKEFILE)
  # This is a list which, when referenced below, will be joined by
  # spaces and inserted before the command is parsed.
  set(HIDE_OUTPUT ">;/dev/null")
endif()

#
# Building out of tree.  Copy everything to the binary directory so that the
# perl install scripts will worlk properly.
#
file(COPY MythTV.pm IO MythTV DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

#
# Install the MythTV version where the perl bindings can find it.
#
configure_file(Makefile.PL.in Makefile.PL @ONLY)

#
# Use the traditional perl Makefile.PL method to generate the build files. This
# trio of cmake statements ensures that this process occurs once and only once.
#
add_custom_command(
  OUTPUT perl-bindings.stamp
  COMMAND
    ${PERL_EXECUTABLE} Makefile.PL MAKEFILE=Makefile.perl
    PREFIX="${CMAKE_INSTALL_PREFIX}" ${MYTH_PERL_CONFIG_OPTS} ${HIDE_OUTPUT}
  COMMAND ${MAKE_EXECUTABLE} -f Makefile.perl ${HIDE_OUTPUT}
  COMMAND touch perl-bindings.stamp
  DEPENDS Makefile.PL)
add_custom_target(perl_bindings DEPENDS perl-bindings.stamp)
add_dependencies(bindings perl_bindings)

#
# Call the perl installer to do the install.
#
install(
  CODE "execute_process(COMMAND ${MAKE_EXECUTABLE} -f Makefile.perl pure_install
                                PREFIX=${CMAKE_INSTALL_PREFIX}
                                PERL_INSTALL_ROOT=${MYTH_BINDINGS_INSTALL_ROOT}
                              WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

# Add additional files and directories to make clean
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                                    "output;blib;pm_to_blib;MakefilePerl")

=== external/FFmpeg/Makefile ===
MAIN_MAKEFILE=1
include ffbuild/config.mak

vpath %.c    $(SRC_PATH)
vpath %.cpp  $(SRC_PATH)
vpath %.h    $(SRC_PATH)
vpath %.inc  $(SRC_PATH)
vpath %.m    $(SRC_PATH)
vpath %.S    $(SRC_PATH)
vpath %.asm  $(SRC_PATH)
vpath %.rc   $(SRC_PATH)
vpath %.v    $(SRC_PATH)
vpath %.texi $(SRC_PATH)
vpath %.cu   $(SRC_PATH)
vpath %.ptx  $(SRC_PATH)
vpath %.metal $(SRC_PATH)
vpath %/fate_config.sh.template $(SRC_PATH)

TESTTOOLS   = audiogen videogen rotozoom tiny_psnr tiny_ssim base64 audiomatch
HOSTPROGS  := $(TESTTOOLS:%=tests/%) doc/print_options

ALLFFLIBS =            \
    avcodec            \
    avdevice           \
    avfilter           \
    avformat           \
    avutil             \
    swscale            \
    swresample         \

# $(FFLIBS-yes) needs to be in linking order
FFLIBS-$(CONFIG_AVDEVICE)   += avdevice
FFLIBS-$(CONFIG_AVFILTER)   += avfilter
FFLIBS-$(CONFIG_AVFORMAT)   += avformat
FFLIBS-$(CONFIG_AVCODEC)    += avcodec
FFLIBS-$(CONFIG_SWRESAMPLE) += swresample
FFLIBS-$(CONFIG_SWSCALE)    += swscale

FFLIBS := avutil

DATA_FILES := $(wildcard $(SRC_PATH)/presets/*.ffpreset) $(SRC_PATH)/doc/ffprobe.xsd

SKIPHEADERS = compat/w32pthreads.h

# first so "all" becomes default target
all: all-yes

include $(SRC_PATH)/tools/Makefile
include $(SRC_PATH)/ffbuild/common.mak

FF_EXTRALIBS := $(FFEXTRALIBS)
FF_DEP_LIBS  := $(DEP_LIBS)
FF_STATIC_DEP_LIBS := $(STATIC_DEP_LIBS)

$(TOOLS): %$(EXESUF): %.o
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $(filter-out $(FF_DEP_LIBS), $^) $(EXTRALIBS-$(*F)) $(EXTRALIBS) $(ELIBS)

target_dec_%_fuzzer$(EXESUF): target_dec_%_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

target_enc_%_fuzzer$(EXESUF): target_enc_%_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/target_bsf_%_fuzzer$(EXESUF): tools/target_bsf_%_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

target_dem_%_fuzzer$(EXESUF): target_dem_%_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/target_dem_fuzzer$(EXESUF): tools/target_dem_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/target_io_dem_fuzzer$(EXESUF): tools/target_io_dem_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/target_sws_fuzzer$(EXESUF): tools/target_sws_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/target_swr_fuzzer$(EXESUF): tools/target_swr_fuzzer.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $^ $(ELIBS) $(FF_EXTRALIBS) $(LIBFUZZER_PATH)

tools/enum_options$(EXESUF): ELIBS = $(FF_EXTRALIBS)
tools/enum_options$(EXESUF): $(FF_DEP_LIBS)
tools/enc_recon_frame_test$(EXESUF): $(FF_DEP_LIBS)
tools/enc_recon_frame_test$(EXESUF): ELIBS = $(FF_EXTRALIBS)
tools/scale_slice_test$(EXESUF): $(FF_DEP_LIBS)
tools/scale_slice_test$(EXESUF): ELIBS = $(FF_EXTRALIBS)
tools/sofa2wavs$(EXESUF): ELIBS = $(FF_EXTRALIBS)
tools/uncoded_frame$(EXESUF): $(FF_DEP_LIBS)
tools/uncoded_frame$(EXESUF): ELIBS = $(FF_EXTRALIBS)
tools/target_dec_%_fuzzer$(EXESUF): $(FF_DEP_LIBS)
tools/target_dem_%_fuzzer$(EXESUF): $(FF_DEP_LIBS)

CONFIGURABLE_COMPONENTS =                                           \
    $(wildcard $(FFLIBS:%=$(SRC_PATH)/lib%/all*.c))                 \
    $(SRC_PATH)/libavcodec/bitstream_filters.c                      \
    $(SRC_PATH)/libavcodec/hwaccels.h                               \
    $(SRC_PATH)/libavcodec/parsers.c                                \
    $(SRC_PATH)/libavformat/protocols.c                             \

config_components.h: ffbuild/.config
ffbuild/.config: $(CONFIGURABLE_COMPONENTS)
	@-tput bold 2>/dev/null
	@-printf '\nWARNING: $(?) newer than config_components.h, rerun configure\n\n'
	@-tput sgr0 2>/dev/null

SUBDIR_VARS := CLEANFILES FFLIBS HOSTPROGS TESTPROGS TOOLS               \
               HEADERS ARCH_HEADERS BUILT_HEADERS SKIPHEADERS            \
               ARMV5TE-OBJS ARMV6-OBJS ARMV8-OBJS VFP-OBJS NEON-OBJS     \
               ALTIVEC-OBJS VSX-OBJS MMX-OBJS X86ASM-OBJS                \
               MIPSFPU-OBJS MIPSDSPR2-OBJS MIPSDSP-OBJS MSA-OBJS         \
               MMI-OBJS LSX-OBJS LASX-OBJS RV-OBJS RVV-OBJS RVVB-OBJS    \
               OBJS SHLIBOBJS STLIBOBJS HOSTOBJS TESTOBJS SIMD128-OBJS

define RESET
$(1) :=
$(1)-yes :=
endef

define DOSUBDIR
$(foreach V,$(SUBDIR_VARS),$(eval $(call RESET,$(V))))
SUBDIR := $(1)/
include $(SRC_PATH)/$(1)/Makefile
-include $(SRC_PATH)/$(1)/$(ARCH)/Makefile
-include $(SRC_PATH)/$(1)/$(INTRINSICS)/Makefile
include $(SRC_PATH)/ffbuild/library.mak
endef

$(foreach D,$(FFLIBS),$(eval $(call DOSUBDIR,lib$(D))))

include $(SRC_PATH)/fftools/Makefile
#include $(SRC_PATH)/doc/Makefile
#include $(SRC_PATH)/doc/examples/Makefile

$(ALLFFLIBS:%=lib%/version.o): libavutil/ffversion.h

$(PROGS): %$(PROGSSUF)$(EXESUF): %$(PROGSSUF)_g$(EXESUF)
ifeq ($(STRIPTYPE),direct)
	$(STRIP) -o $@ $<
else
	$(RM) $@
	$(CP) $< $@
	$(STRIP) $@
endif

%$(PROGSSUF)_g$(EXESUF): $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LDEXEFLAGS) $(LD_O) $(OBJS-$*) $(FF_EXTRALIBS)

VERSION_SH  = $(SRC_PATH)/ffbuild/version.sh
ifeq ($(VERSION_TRACKING),yes)
GIT_LOG     = $(SRC_PATH)/.git/logs/HEAD
endif

.version: $(wildcard $(GIT_LOG)) $(VERSION_SH) ffbuild/config.mak
.version: M=@

ifneq ($(VERSION_TRACKING),yes)
libavutil/ffversion.h .version: REVISION=unknown
endif
libavutil/ffversion.h .version:
	$(M)revision=$(REVISION) $(VERSION_SH) $(SRC_PATH) libavutil/ffversion.h $(EXTRA_VERSION)
	$(Q)touch .version

# force version.sh to run whenever version might have changed
-include .version

install: install-libs install-headers

install-libs: install-libs-yes

install-data: $(DATA_FILES)
	$(Q)mkdir -p "$(DATADIR)"
	$(INSTALL) -m 644 $(DATA_FILES) "$(DATADIR)"

uninstall: uninstall-data uninstall-headers uninstall-libs uninstall-pkgconfig

uninstall-data:
	$(RM) -r "$(DATADIR)"

clean::
	$(RM) $(CLEANSUFFIXES)
	$(RM) $(addprefix compat/,$(CLEANSUFFIXES)) $(addprefix compat/*/,$(CLEANSUFFIXES)) $(addprefix compat/*/*/,$(CLEANSUFFIXES))
	$(RM) -r coverage-html
	$(RM) -rf coverage.info coverage.info.in lcov

distclean:: clean
	$(RM) .version config.asm config.h config_components.h mapfile  \
		ffbuild/.config ffbuild/config.* libavutil/avconfig.h \
		version.h libavutil/ffversion.h libavcodec/codec_names.h \
		libavcodec/bsf_list.c libavformat/protocol_list.c \
		libavcodec/codec_list.c libavcodec/parser_list.c \
		libavfilter/filter_list.c libavdevice/indev_list.c libavdevice/outdev_list.c \
		libavformat/muxer_list.c libavformat/demuxer_list.c
ifeq ($(SRC_LINK),src)
	$(RM) src
endif
	$(RM) -rf doc/examples/pc-uninstalled

config:
	$(SRC_PATH)/configure $(value FFMPEG_CONFIGURATION)

build: all alltools examples testprogs
check: all alltools examples testprogs fate

include $(SRC_PATH)/tests/Makefile

$(sort $(OUTDIRS)):
	$(Q)mkdir -p $@

# Dummy rule to stop make trying to rebuild removed or renamed headers
%.h:
	@:

# Disable suffix rules.  Most of the builtin rules are suffix rules,
# so this saves some time on slow systems.
.SUFFIXES:

.PHONY: all all-yes alltools build check config testprogs
.PHONY: *clean install* uninstall*

=== external/libmythdvdnav/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

# This is set up to be a separate sub-project, but is currently
# included by the MythTV sub-project.
project(
  DVDREAD
  VERSION 6.0.0
  LANGUAGES C)
set(DVDREAD_VERSION_MICRO ${DVDREAD_VERSION_PATCH})

set(DVDNAV_MAJOR 6)
set(DVDNAV_MINOR 0)
set(DVDNAV_SUB 0)

include(CheckIncludeFile)
include(CheckSymbolExists)

# Remove some of the compilation flags that were added to MythTV by
# the -Wall flag.
unset(CFLAGS)
list(APPEND CFLAGS " -Wno-maybe-uninitialized")
list(APPEND CFLAGS " -Wno-unneeded-internal-declaration") # clang
list(APPEND CFLAGS " -Wno-unused-but-set-variable")
list(APPEND CFLAGS " -Wno-unused-variable")
# Remove some of the compilation flags that were added to MythTV by
# the -Wextra flag.
list(APPEND CFLAGS " -Wno-implicit-fallthrough")
list(APPEND CFLAGS " -Wno-unused-parameter")
# libdvdread uses packed structs
list(APPEND CFLAGS " -Wno-address-of-packed-member")

foreach(_FLAG IN LISTS CFLAGS)
  string(SUBSTRING ${_FLAG} 1 -1 _NAME)
  check_c_compiler_flag("${_FLAG}" HAVE_C_${_NAME})
  if(HAVE_C_${_NAME})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_FLAG}")
  endif()
endforeach()

#
# Compile this library as a static library on Android because of the circular
# linking dependency issue with libmythtv (specifically the calls to the
# MythFile* functions).  Cmake only enables PIC code by default on shared
# libraries, so need to enable PIC on the library later after its defined.
#
if(ANDROID OR WIN32)
  set(LIBRARY_TYPE STATIC)
else()
  set(LIBRARY_TYPE SHARED)
endif()

set(LIBDVDNAV_HEADERS
  dvdnav/dvdnav/dvd_types.h
  dvdnav/dvdnav/dvdnav.h
  dvdnav/dvdnav/dvdnav_events.h
  )

set(LIBDVDREAD_HEADERS
  dvdread/dvdread/bitreader.h
  dvdread/dvdread/dvd_reader.h
  dvdread/dvdread/dvd_udf.h
  dvdread/dvdread/ifo_print.h
  dvdread/dvdread/ifo_read.h
  dvdread/dvdread/ifo_types.h
  dvdread/dvdread/nav_print.h
  dvdread/dvdread/nav_read.h
  dvdread/dvdread/nav_types.h
  )

add_library(
  mythdvdnav
  ${LIBRARY_TYPE}
  ${LIBDVDNAV_HEADERS}
  dvdnav/dvdnav.c
  dvdnav/dvdnav_internal.h
  dvdnav/highlight.c
  dvdnav/navigation.c
  dvdnav/read_cache.c
  dvdnav/read_cache.h
  dvdnav/searching.c
  dvdnav/settings.c
  dvdnav/vm/decoder.c
  dvdnav/vm/decoder.h
  dvdnav/vm/getset.c
  dvdnav/vm/getset.h
  dvdnav/vm/play.c
  dvdnav/vm/play.h
  dvdnav/vm/vm.c
  dvdnav/vm/vm.h
  dvdnav/vm/vm_serialize.c
  dvdnav/vm/vm_serialize.h
  dvdnav/vm/vmcmd.c
  dvdnav/vm/vmcmd.h
  dvdnav/vm/vmget.c
  ${LIBDVDREAD_HEADERS}
  dvdread/bitreader.c
  dvdread/bswap.h
  dvdread/dvd_input.c
  dvdread/dvd_input.h
  dvdread/dvd_reader.c
  dvdread/dvd_udf.c
  dvdread/dvdread_internal.h
  dvdread/ifo_print.c
  dvdread/ifo_read.c
  dvdread/md5.c
  dvdread/md5.h
  dvdread/nav_print.c
  dvdread/nav_read.c
  include/libmythtv/mythtvexp.h
  include/libmythtv/io/mythiowrapper.h)

if(WIN32)
  target_sources(mythdvdnav PRIVATE
    dvdread/win32_dlfcn.h
    )
endif()

# Don't allow the hidden visibility flag for this target.
set_property(TARGET mythdvdnav PROPERTY C_VISIBILITY_PRESET)

# libdvdread
pkg_check_modules(DVDCSS "libdvdcss>=1.2" IMPORTED_TARGET)
if(TARGET PkgConfig::DVDCSS)
  target_link_libraries(mythdvdnav PRIVATE PkgConfig::DVDCSS)
  set(HAVE_DVDCSS_DVDCSS_H 1)
else()
  check_include_file(dlfcn.h HAVE_DLFCN_H)
  target_link_libraries(mythdvdnav PUBLIC ${CMAKE_DL_LIBS})
endif()

check_include_file(sys/param.h HAVE_SYS_PARAM_H)

# libdvdnav and libdvdread
check_symbol_exists(gettimeofday "sys/time.h" HAVE_GETTIMEOFDAY)
if(CMAKE_CXX_BYTE_ORDER STREQUAL "BIG_ENDIAN")
  set(WORDS_BIGENDIAN 1)
endif()

# Create stripped down config.h with only the symbols that are used in this
# directory.
configure_file(config.h.in config.h @ONLY)

configure_file(dvdread/dvdread/version.h.in dvdread/dvdread/version.h @ONLY)
configure_file(dvdnav/dvdnav/version.h.in dvdnav/dvdnav/version.h @ONLY)

# libdvdnav
target_compile_definitions(mythdvdnav PRIVATE
  HAVE_CONFIG_H
  )

# Instead of creating a circular dependency by adding an include path into
# external/libmythdvdnav that points over to libs/libmythxxx, just copy in the
# files that are needed.
add_custom_command(
  OUTPUT include/libmythtv include/libmythtv/io
  COMMAND ${CMAKE_COMMAND} -E make_directory
          include/libmythtv/io)
add_custom_command(
  OUTPUT include/libmythtv/mythtvexp.h
  DEPENDS include/libmythtv
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
          ${MythTV_SOURCE_DIR}/libs/libmythtv/mythtvexp.h include/libmythtv)
add_custom_command(
  OUTPUT include/libmythtv/io/mythiowrapper.h
  DEPENDS include/libmythtv/io
  COMMAND
    ${CMAKE_COMMAND} -E copy_if_different
    ${MythTV_SOURCE_DIR}/libs/libmythtv/io/mythiowrapper.h include/libmythtv/io)

#
# The MythTV customization to dvdnav adds references to the MythFile* functions,
# which are defined in libs/libmythtv. to allow these symbols to remain
# undefined while linking mythdvdnav, the "-Wl,--no-undefined" option cannot be
# a part of the link line. The android toolchain file adds this argument by
# default, so it needs to be stripped here.
#
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  if(CMAKE_SHARED_LINKER_FLAGS)
    string(REPLACE "-Wl,--no-undefined" "" CMAKE_SHARED_LINKER_FLAGS
                   ${CMAKE_SHARED_LINKER_FLAGS})
  endif()

  # Compiles with clang on Apple specifically need "-undefined dynamic_lookup"
  # added to the linker flags.  This prevents the linker from failing
  # immediately with complaints about undefined symbols, and defers the lookup
  # to the loader.  Its not clear if this helps on Android (since the explicit
  # opposite has just been removed), but it couldn't hurt.
  target_link_options(mythdvdnav PRIVATE -undefined dynamic_lookup)
endif()

#
# Compile PIC code on android.  The default for PIC code is ON for shared
# libraries, but on android this library is built as a static library because of
# the circular linking dependency issue with libmythtv.
#
if(ANDROID)
  set_target_properties(
    mythdvdnav PROPERTIES POSITION_INDEPENDENT_CODE ON
                          SUFFIX "-${CMAKE_PROJECT_VERSION_MAJOR}.a")
endif()

target_include_directories(
  mythdvdnav
  PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/dvdnav ${CMAKE_CURRENT_SOURCE_DIR}/dvdread
  PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/include
  # for libdvdnav version.h
  ${CMAKE_CURRENT_BINARY_DIR}/dvdnav/dvdnav
  # for libdvdread version.h
  ${CMAKE_CURRENT_BINARY_DIR}/dvdread/dvdread
  )

install(
  TARGETS mythdvdnav
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
  ${LIBDVDNAV_HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/dvdnav/dvdnav/version.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mythtv/dvdnav
  )

install(FILES
  ${LIBDVDREAD_HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/dvdread/dvdread/version.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mythtv/dvdread
  )

=== external/libudfread/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

cmake_minimum_required(VERSION 3.20)
project(
  libudfread
  VERSION 1.2.0
  LANGUAGES C)
set(BUILD_SHARED_LIBS YES)

# Inject code from cmake provided modules
include(CheckIncludeFile)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

check_include_file(fcntl.h HAVE_FCNTL_H)
check_include_file(pthread.h HAVE_PTHREAD_H)
check_include_file(unistd.h HAVE_UNISTD_H)

set(HEADERS blockinput.h udfread.h udfread-version.h)

add_library(udfread
  ${HEADERS}
  attributes.h
  default_blockinput.c
  default_blockinput.h
  ecma167.c
  ecma167.h
  udfread-version.c
  udfread.c
  )

# Create stripped down config.h with only the symbols that are used in this
# directory.
configure_file(config.h.in config.h @ONLY)

set_target_properties(
  udfread
  PROPERTIES COMPILE_DEFINITIONS "HAVE_CONFIG_H"
             VERSION ${libudfread_VERSION}
             SOVERSION ${libudfread_VERSION_MAJOR})

target_compile_definitions(udfread PRIVATE UDFREAD_API_EXPORT)

target_include_directories(
  udfread
  PUBLIC ${CMAKE_INSTALL_INCLUEDIR}/udfread
  PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

#
# Install libudfread
#
install(TARGETS udfread LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

#
# Install headers
#
install(FILES ${HEADERS} DESTINATION include/udfread)

#
# Create and install pkg-config file
#
set(VERSION ${libudfread_VERSION})
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_FULL_BINDIR})
set(libdir ${CMAKE_INSTALL_FULL_LIBDIR})
set(includedir ${CMAKE_INSTALL_FULL_INCLUDEDIR})
configure_file(libudfread.pc.in libudfread.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/libudfread.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== libs/libmythbase/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

#
# Enumerate all headers
#

set(LIBMYTHBASE_HEADERS
    autodeletedeque.h
    compat.h
    dbutil.h
    exitcodes.h
    filesysteminfo.h
    hardwareprofile.h
    iso3166.h
    iso639.h
    lcddevice.h
    loggingserver.h
    mthread.h
    mthreadpool.h
    mythbaseexp.h
    mythcdrom.h
    mythchrono.h
    mythcommandlineparser.h
    mythcorecontext.h
    mythdate.h
    mythdb.h
    mythdbcheck.h
    mythdbcon.h
    mythdbparams.h
    mythdeque.h
    mythdirs.h
    mythdownloadmanager.h
    mythevent.h
    mythlocale.h
    mythlogging.h
    mythmedia.h
    mythmiscutil.h
    mythobservable.h
    mythplugin.h
    mythpluginapi.h
    mythpluginexport.h
    mythrandom.h
    mythsession.h
    mythsingledownload.h
    mythsocket.h
    mythsocket_cb.h
    mythsorthelper.h
    mythstorage.h
    mythsystem.h
    mythsystemlegacy.h
    mythtimer.h
    mythtranslation.h
    mythtypes.h
    netgrabbermanager.h
    netutils.h
    referencecounter.h
    referencecounterlist.h
    remotefile.h
    rssparse.h
    rssmanager.h
    serverpool.h
    signalhandling.h
    sizetliteral.h
    storagegroup.h
    stringutil.h
    threadedfilewriter.h
    verbosedefs.h)

set(LIBMYTHBASE_HEADERS_NOT_INSTALLED
    mythbinaryplist.h
    configuration.h
    housekeeper.h
    logging.h
    mconcurrent.h
    mythappname.h
    mythhdd.h
    mythpower.h
    mythscheduler.h
    mythsystemprivate.h
    mythtimezone.h
    portchecker.h
    unzip2.h
    unziputil.h)

set(LIBMYTHBASE_HTTP_HEADERS
    http/mythhttpcache.h
    http/mythhttpcommon.h
    http/mythhttpdata.h
    http/mythhttpencoding.h
    http/mythhttpfile.h
    http/mythhttpinstance.h
    http/mythhttpmetamethod.h
    http/mythhttpmetaservice.h
    http/mythhttpparser.h
    http/mythhttpranges.h
    http/mythhttprequest.h
    http/mythhttpresponse.h
    http/mythhttprewrite.h
    http/mythhttproot.h
    http/mythhttps.h
    http/mythhttpserver.h
    http/mythhttpservice.h
    http/mythhttpservices.h
    http/mythhttpsocket.h
    http/mythhttpthread.h
    http/mythhttpthreadpool.h
    http/mythhttptypes.h
    http/mythmimedatabase.h
    http/mythmimetype.h
    http/mythwebsocket.h
    http/mythwebsocketevent.h
    http/mythwebsockettypes.h
    http/mythwsdl.h
    http/mythxsd.h
    http/serialisers/mythcborserialiser.h
    http/serialisers/mythjsonserialiser.h
    http/serialisers/mythserialiser.h
    http/serialisers/mythxmlplistserialiser.h
    http/serialisers/mythxmlserialiser.h)

#
# Declare the library
#
add_library(
  mythbase
  # Include headers here so the they will be scanned for Qt classes
  # and potentially have MOC invoked on them.
  ${LIBMYTHBASE_HEADERS}
  ${LIBMYTHBASE_HEADERS_NOT_INSTALLED}
  ${LIBMYTHBASE_HTTP_HEADERS}
  configuration.cpp
  dbcheckcommon.cpp
  dbutil.cpp
  filesysteminfo.cpp
  hardwareprofile.cpp
  housekeeper.cpp
  http/mythhttpcache.cpp
  http/mythhttpcommon.cpp
  http/mythhttpdata.cpp
  http/mythhttpencoding.cpp
  http/mythhttpfile.cpp
  http/mythhttpinstance.cpp
  http/mythhttpmetamethod.cpp
  http/mythhttpmetaservice.cpp
  http/mythhttpparser.cpp
  http/mythhttpranges.cpp
  http/mythhttprequest.cpp
  http/mythhttpresponse.cpp
  http/mythhttprewrite.cpp
  http/mythhttproot.cpp
  http/mythhttps.cpp
  http/mythhttpserver.cpp
  http/mythhttpservice.cpp
  http/mythhttpservices.cpp
  http/mythhttpsocket.cpp
  http/mythhttpthread.cpp
  http/mythhttpthreadpool.cpp
  http/mythmimedatabase.cpp
  http/mythmimetype.cpp
  http/mythwebsocket.cpp
  http/mythwebsocketevent.cpp
  http/mythwebsockettypes.cpp
  http/mythwsdl.cpp
  http/mythxsd.cpp
  http/serialisers/mythcborserialiser.cpp
  http/serialisers/mythjsonserialiser.cpp
  http/serialisers/mythserialiser.cpp
  http/serialisers/mythxmlplistserialiser.cpp
  http/serialisers/mythxmlserialiser.cpp
  iso3166.cpp
  iso639.cpp
  lcddevice.cpp
  logging.cpp
  loggingserver.cpp
  mthread.cpp
  mthreadpool.cpp
  mythbinaryplist.cpp
  mythcdrom.cpp
  mythcommandlineparser.cpp
  mythconfig.h.in
  mythcorecontext.cpp
  mythdate.cpp
  mythdb.cpp
  mythdbcon.cpp
  mythdbparams.cpp
  mythdirs.cpp
  mythdownloadmanager.cpp
  mythevent.cpp
  mythhdd.cpp
  mythlocale.cpp
  mythmedia.cpp
  mythmiscutil.cpp
  mythobservable.cpp
  mythplugin.cpp
  mythpower.cpp
  mythrandom.cpp
  mythsession.cpp
  mythsingledownload.cpp
  mythsocket.cpp
  mythsorthelper.cpp
  mythstorage.cpp
  mythsystem.cpp
  mythsystemlegacy.cpp
  mythtimer.cpp
  mythtimezone.cpp
  mythtranslation.cpp
  mythtypes.cpp
  mythversion.cpp
  mythversion.h.in
  netgrabbermanager.cpp
  netutils.cpp
  portchecker.cpp
  referencecounter.cpp
  remotefile.cpp
  rssparse.cpp
  rssmanager.cpp
  serverpool.cpp
  signalhandling.cpp
  storagegroup.cpp
  stringutil.cpp
  threadedfilewriter.cpp
  unzip2.cpp
  unziputil.cpp)

#
# All remaining target information
#

target_compile_definitions(mythbase PRIVATE MBASE_API)

set_source_files_properties(
  mythdirs.cpp
  PROPERTIES
    COMPILE_DEFINITIONS
    "RUNPREFIX=\"${MYTH_RUN_PREFIX}\";LIBDIRNAME=\"${CMAKE_INSTALL_LIBDIR}\"")
target_include_directories(
  mythbase
  PRIVATE .
  PUBLIC # Includes with directory name
         $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/libs>
         # Generated includes with dir name
         $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/libs>
         # For mythconfig.h and mythversion.h
         $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  INTERFACE $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/mythtv>)

target_link_libraries(
  mythbase
  PUBLIC Qt${QT_VERSION_MAJOR}::Core
         Qt${QT_VERSION_MAJOR}::Network
         Qt${QT_VERSION_MAJOR}::Sql
         Qt${QT_VERSION_MAJOR}::Widgets
         Qt${QT_VERSION_MAJOR}::Xml
         PkgConfig::LIBUDFREAD
         PkgConfig::LIBZIP
         $<TARGET_NAME_IF_EXISTS:Qt6::Core5Compat>
         $<TARGET_NAME_IF_EXISTS:X11::X11>
         $<TARGET_NAME_IF_EXISTS:Threads::Threads>
         ZLIB::ZLIB)
if(ANDROID)
  target_link_libraries(mythbase PRIVATE log)
elseif(WIN32)
  target_link_libraries(mythbase PUBLIC ssp wsock32)
endif()

#
# conditionally included code
#
if(UNIX)
  target_sources(mythbase PRIVATE mythsystemunix.h mythsystemunix.cpp)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  target_sources(mythbase PRIVATE mythcdrom-linux.h mythcdrom-linux.cpp)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  target_sources(mythbase PRIVATE mythcdrom-freebsd.h mythcdrom-freebsd.cpp)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  target_sources(
    mythbase
    PRIVATE mythcdrom-darwin.h mythcdrom-darwin.cpp platforms/mythpowerosx.h
            platforms/mythpowerosx.cpp platforms/mythcocoautils.h
            platforms/mythcocoautils.mm)
  target_link_libraries(
    mythbase PRIVATE ${APPLE_IOKIT_LIBRARY} ${APPLE_COCOA_LIBRARY}
                     ${APPLE_COREFOUNDATION_LIBRARY})
elseif(WIN32)
  target_sources(mythbase PRIVATE mythsystemwindows.h mythsystemwindows.cpp)
endif()

if(TARGET PkgConfig::LIBDNS_SD)
  target_sources(mythbase PRIVATE bonjourregister.h bonjourregister.cpp)
  target_link_libraries(mythbase PRIVATE PkgConfig::LIBDNS_SD)
endif()

if(TARGET Qt${QT_VERSION_MAJOR}::DBus)
  target_sources(mythbase PRIVATE platforms/mythpowerdbus.h
                                  platforms/mythpowerdbus.cpp)
  target_link_libraries(mythbase PRIVATE Qt${QT_VERSION_MAJOR}::DBus)
endif()

#
# Generated files section
#
configure_file(mythversion.h.in mythversion.h @ONLY)
configure_file(mythconfig.h.in mythconfig.h @ONLY)

#
# Regenerate version.h every compile
#
add_custom_target(
  update_version_h ALL
  COMMAND ${PROJECT_SOURCE_DIR}/version.sh $<IF:$<BOOL:${VERBOSE}>,,-q>
  ${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR}
  COMMENT "Update version.h"
  BYPRODUCTS version.h)

#
# Installation section
#

install(TARGETS mythbase LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES ${LIBMYTHBASE_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/version.h
              ${CMAKE_CURRENT_BINARY_DIR}/mythversion.h
              ${CMAKE_CURRENT_BINARY_DIR}/mythconfig.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mythtv/libmythbase)

if(ANDROID)
  set(DEST_PREFIX mythbase${CMAKE_SHARED_LIBRARY_SUFFIX_C})
  string(REPLACE ".so" "" DEST_PREFIX ${DEST_PREFIX})
  install(
    FILES android-dependencies.xml
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RENAME ${DEST_PREFIX}-android-dependencies.xml)
endif(ANDROID)

=== libs/libmythfreemheg/CMakeLists.txt ===
#
# Copyright (C) 2022-2023 David Hampton
#
# See the file LICENSE_FSF for licensing information.
#

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

#
# Define the library
#

add_library(
  mythfreemheg
  Actions.cpp
  Actions.h
  ASN1Codes.h
  BaseActions.cpp
  BaseActions.h
  BaseClasses.cpp
  BaseClasses.h
  Bitmap.cpp
  Bitmap.h
  DynamicLineArt.cpp
  DynamicLineArt.h
  Engine.cpp
  Engine.h
  freemheg.h
  Groups.cpp
  Groups.h
  Ingredients.cpp
  Ingredients.h
  Link.cpp
  Link.h
  Logging.h
  ParseBinary.cpp
  ParseBinary.h
  ParseNode.cpp
  ParseNode.h
  ParseText.cpp
  ParseText.h
  Presentable.cpp
  Presentable.h
  Programs.cpp
  Programs.h
  Root.cpp
  Root.h
  Stream.cpp
  Stream.h
  Text.cpp
  Text.h
  TokenGroup.cpp
  TokenGroup.h
  Variables.cpp
  Variables.h
  Visible.cpp
  Visible.h
  )

# Mark appropriate symbols as EXPORT
target_compile_definitions(mythfreemheg PRIVATE MHEG_API)

target_include_directories(
  mythfreemheg
  PUBLIC # For including without directory name
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
         # For including with directory name
         $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/libs>
  INTERFACE $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/mythtv>)

target_link_libraries(mythfreemheg PUBLIC Qt${QT_VERSION_MAJOR}::Core
                                          Qt${QT_VERSION_MAJOR}::Gui)

install(TARGETS mythfreemheg LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
mythtv (2:36.0+fixes.20260210.a312d68f-0ubuntu1) resolute; urgency=medium

  * New upstream version.

 -- Mario Limonciello <superm1@debian.org>  Tue, 10 Feb 2026 07:51:37 -0600

mythtv (2:36.0+fixes) noble; urgency=medium

  * Dummy entry to bump version to fixes/36

 -- Roland Ernst <rcrernst@gmail.com>  Thu, 29 Jan 2026 21:08:26 +0100

mythtv (2:36.0~master) noble; urgency=medium

  * Dummy entry to bump version to 36

 -- Roland Ernst <rcrernst@gmail.com>  Thu, 13 Feb 2024 20:15:49 +0100

=== debian/control ===
Source: mythtv
Section: graphics
Priority: optional
Maintainer: MythTV Ubuntu Maintainers <ubuntu-mythtv@lists.ubuntu.com>
Uploaders:
 Mario Limonciello <superm1@ubuntu.com>,
 Andres Mejia <amejia@debian.org>,
Homepage: http://www.mythtv.org
Standards-Version: 3.9.4
Vcs-Git: git://github.com/MythTV/packaging.git
Build-Conflicts:
 libqt3-mt-dev,
Build-Depends:
 ccache,
 debhelper (>= 10),
 default-libmysqlclient-dev | libmysqlclient-dev,
 dh-python,
 fftw-dev,
 git,
 help2man,
 libasound2-dev,
 libass-dev,
 libavahi-compat-libdnssd-dev,
 libavc1394-dev,
 libbluray-dev,
 libcdaudio-dev,
 libcdio-cdda-dev,
 libcdio-dev,
 libcdio-paranoia-dev,
 libcdparanoia-dev | libcdparanoia0-dev,
 libcec-dev,
 libclass-dbi-perl,
 libcoverart-dev,
 libdate-manip-perl,
 libdatetime-format-iso8601-perl,
 libdbd-mysql-perl,
 libdiscid-dev,
 libdrm-dev,
 libdvdnav-dev,
 libdvdread-dev | libdvdread3-dev,
 libexif-dev (>= 0.6.9-6),
 libexiv2-dev,
 libfaad-dev | libfaad2-dev,
 libfftw3-dev,
 libflac-dev,
 libfreetype6-dev,
 libgl1-mesa-dev | xlibmesa-gl-dev | xlibmesa-dev | libgl-dev,
 libgnutls28-dev,
 libhdhomerun-dev,
 libiec61883-dev,
 libimage-size-perl,
 libimlib2-dev,
 libio-socket-inet6-perl,
 libjson-perl,
 liblircclient-dev | liblirc-dev,
 liblzo2-dev,
 libmad0-dev,
 libmp3lame-dev | liblame-dev,
 libmusicbrainz5-dev,
 libnet-upnp-perl,
 libpulse-dev,
 libqt5opengl5-dev,
 libraspberrypi-dev [armhf],
 libsamplerate0-dev,
 libsoap-lite-perl,
 libsoundtouch-dev,
 libssl-dev,
 libsystemd-dev,
 libtag1-dev,
 libtiff5-dev | libtiff4-dev | libtiff-dev,
 libudev-dev,
 libva-dev,
 libvdpau-dev | nvidia-190-libvdpau-dev [i386 amd64] | nvidia-185-libvdpau-dev [i386 amd64] | nvidia-180-libvdpau-dev [i386 amd64],
 libvisual-0.4-dev,
 libvorbis-dev,
 libvpx-dev,
 libwww-perl,
 libx264-dev,
 libxcb-shm0-dev,
 libxext-dev | xlibs-static-dev (<< 6.8.1-1),
 libxinerama-dev | xlibs-static-dev (<< 6.8.1-1),
 libxml-simple-perl,
 libxml-xpath-perl,
 libxml2-dev,
 libxnvctrl-dev,
 libxrandr-dev,
 libxv-dev,
 libxvmc-dev | xlibs-static-dev (<< 6.8.1-1),
 libxxf86vm-dev | xlibs-static-dev (<< 6.8.1-1),
 libzip-dev,
 linux-kernel-headers | linux-headers-generic,
 lsb-release,
 nasm,
 po-debconf,
 python3,
 python3-lxml,
 python3-mysqldb,
 python3-pip,
 python3-requests,
 python3-setuptools,
 qt5-qmake,
 qtdeclarative5-dev,
 qtwebengine5-dev,
 qtscript5-dev,
 quilt,
 uuid-dev,

Package: mythtv
Architecture: all
Depends:
 default-mysql-server | virtual-mysql-server | mysql-server-5.7 | mysql-server-5.6 | mariadb-server,
 mythtv-backend,
 mythtv-database,
 mythtv-frontend,
 ntp | time-daemon | ntp-simple,
 ${misc:Depends},
Suggests:
 mythtv-doc,
Description: Personal video recorder application (client and server)
 MythTV implements the following PVR features, and more, with a
 unified graphical interface:
 .
  - Basic 'live-tv' functionality. Pause/Fast Forward/Rewind "live" TV.
  - Video compression using RTjpeg or MPEG-4
  - Program listing retrieval using XMLTV
  - Themable, semi-transparent on-screen display
  - Electronic program guide
  - Scheduled recording of TV programs
  - Resolution of conflicts between scheduled recordings
  - Basic video editing
 .
 http://www.mythtv.org/
 .
 This package will install a complete MythTV client/server environment on a
 single system.  If you are intended on using this as your only MythTV machine,
 and this machine is already configured as a desktop, this package will get you
 up and running switfly.
 .
 If you are intended on installing this on a standalone/non-desktop machine,
 you should look into the Metapackages available:
 mythtv-backend-master (backend with a local database)
 mythtv-backend (backend needing a remote database)

Package: mythtv-common
Architecture: amd64 arm64
Pre-Depends:
 pwgen,
Depends:
 adduser,
 default-mysql-client | virtual-mysql-client | mysql-client-5.7 | mysql-client-5.6 | mariadb-client,
 fonts-dejavu,
 fonts-droid-fallback | fonts-droid | ttf-droid,
 fonts-freefont-ttf,
 fonts-liberation | ttf-liberation,
 fonts-texgyre | tex-gyre,
 fonts-tlwg-purisa,
 libgnutls30,
 libxml-xpath-perl,
 pciutils,
 python3,
 python3-lxml,
 python3-mysqldb,
 python3-requests,
 python3-requests-cache,
 usbutils,
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Suggests:
 mythtv-doc,
Conflicts:
 mythcontrols,
 mythmusic (<< 0.20.99+trunk14393),
 mythtv (<< 0.8-1),
 mythtv-theme-blootube,
 mythtv-theme-blootube-wide,
 mythtv-theme-blootubelite-wide,
 mythtv-theme-childish,
 mythtv-theme-glass-wide,
 mythtv-theme-gray-osd,
 mythtv-theme-isthmus,
 mythtv-theme-iulius,
 mythtv-theme-metallurgy,
 mythtv-theme-minimalist-wide,
 mythtv-theme-mythcenter,
 mythtv-theme-mythcenter-wide,
 mythtv-theme-neon-wide,
 mythtv-theme-proejctgrayhem-wide,
 mythtv-theme-projectgrayhem,
 mythtv-theme-retro,
 mythtv-theme-titivillus,
 mythtv-themes,
 mythweather (<< 0.20.99+trunk14393),
Replaces:
 mythcontrols,
 mythcontrols (<< 0.20.trunk19500),
 mythmusic (<< 0.20.99+trunk14393),
 mythtv (<< 0.8-1),
 mythtv-backend (<< 2:0.28.0~master.20150106.b8b9a1e-0ubuntu0mythbuntu4),
 mythtv-database (<< 0.24.0~trunk25638),
 mythtv-frontend (<< 0.23.0~trunk23548),
 mythtv-frontend (<< 2:0.28.0+fixes.20161010.38d9ba2-0ubuntu0mythbuntu4),
 mythtv-theme-gray-osd,
 mythtv-theme-isthmus,
 mythtv-theme-mythcenter,
 mythtv-theme-mythcenter-wide,
 mythvideo,
 mythweather (<< 0.20.99+trunk14393),
Breaks:
 mythtv-backend (<< 2:0.28.0~master.20150106.b8b9a1e-0ubuntu0mythbuntu4),
 mythtv-frontend (<< 2:0.28.0+fixes.20161010.38d9ba2-0ubuntu0mythbuntu4),
 mythvideo,
Description: Personal video recorder application (common data)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains infrastructure needed by both the client and the
 server.

Package: mythtv-doc
Architecture: all
Conflicts:
 mythtv (<< 0.8-1),
Section: doc
Replaces:
 mythtv (<< 0.8-1),
Depends:
 ${misc:Depends},
Description: Personal video recorder application (documentation)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains documentation, including the MythTV HOWTO.

Package: mythtv-database
Architecture: all
Depends:
 cron,
 default-mysql-client | virtual-mysql-client | mysql-client-5.7 | mysql-client-5.6 | mariadb-client,
 libdbd-mysql-perl,
 mythtv-common,
 ${misc:Depends},
Recommends:
 update-notifier | update-notifier-kde,
Conflicts:
 mythtv (<< 0.8-1),
 mythtv-common (<< 0.8-2),
Replaces:
 mythtv (<< 0.8-1),
 mythtv-common (<< 0.8-2),
Description: Personal video recorder application (database)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package sets up a MySQL database for use by MythTV. It should be
 installed on the system where the MySQL server resides.

Package: mythtv-backend
Architecture: amd64 arm64
Depends:
 cron,
 libjs-jquery,
 libxml-simple-perl,
 mythtv-common,
 mythtv-transcode-utils,
 python3,
 wget,
 xterm,
 zenity | kdebase-bin,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 mythtv (<< 0.8-1),
 mythweb,
Replaces:
 mythtv (<< 0.8-1),
 mythtv-frontend (<= 0.20-0.4),
 mythweb,
Recommends:
 hdhomerun-config,
 libmyth-python,
 libmythtv-perl,
 logrotate,
 ntp | time-daemon | ntp-simple,
Suggests:
 mythtv-database,
 mythtv-frontend,
 xmltv-util,
Description: Personal video recorder application (server)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains only the server software, which provides video and
 audio capture and encoding services. In order to be useful, it requires a
 mythtv-frontend installation, either on the same system or one reachable
 via the network.
 .
 A database is also required. The mythtv-database package must be installed,
 either on the same system, or one reachable via the network.
 .
 For a complete installation of all MythTV components, install the 'mythtv'
 package.

Package: mythtv-transcode-utils
Architecture: amd64 arm64
Depends:
 mythtv-common,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 mythtv-backend (<< 0.20.2-0ubuntu1),
Replaces:
 mythtv-backend (<< 0.20.2-0ubuntu1),
Suggests:
 mytharchive,
 mythtv-backend,
Description: Utilities used for transcoding MythTV tasks
 Some utilities are applicable for both a frontend or a backend machine.
 This package provides utilities that can be used on both without
 requiring an entire backend to be installed.

Package: mythtv-frontend
Architecture: amd64 arm64
Depends:
 adduser,
 libegl1-mesa-dev [armhf],
 libgles2-mesa-dev [armhf],
 libmyth-python,
 libnotify-bin,
 libwww-perl,
 libxml-simple-perl,
 mythtv-common,
 libqt5webenginewidgets5,
 python3,
 wmctrl,
 zenity | kdebase-bin,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libmythtv-perl,
 python3-pil,
 udisks2 | udisks,
Suggests:
 mythgame,
 mythmusic,
 mythtv-backend,
 mythweather,
 ntp | time-daemon | ntp-simple,
Conflicts:
 mythappearance (<< 0.21.0),
 mythflix (<< 0.23.0),
 mythstream (<< 0.21.0),
 mythtv (<< 0.8-1),
Replaces:
 mythappearance (<< 0.21.0),
 mythtv (<< 0.8-1),
 mythvideo,
Breaks:
 mythvideo,
Description: Personal video recorder application (client)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains only the client software, which provides a front-end
 for playback and configuration. It requires access to a mythtv-backend
 installation, either on the same system or one reachable via the network.
 .
 A database is also required. The mythtv-database package must be installed,
 either on the same system, or one reachable via the network.
 .
 For a complete installation of all MythTV components, install the 'mythtv'
 package.

Package: libmyth
Architecture: amd64 arm64
Section: libs
Depends:
 libqt5sql5-mysql,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libmyth-0.23-0,
 libmyth-0.24-0,
 libmyth-0.25-0,
 libmyth-0.26-0,
 libmyth-0.27-0,
 libmyth-0.28-0,
 libmyth-0.29-0,
 libmyth-29-0,
 mythtv (<< 0.7-5),
Replaces:
 libmyth-0.23-0,
 libmyth-0.24-0,
 libmyth-0.25-0,
 libmyth-0.26-0,
 libmyth-0.27-0,
 libmyth-0.28-0,
 libmyth-0.29-0,
 libmyth-29-0,
 mythtv (<< 0.7-5),
Description: Common library code for MythTV and add-on modules (runtime)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains a shared library, libmyth, which is used by various
 components in the system.

Package: libmyth-dev
Architecture: amd64 arm64
Section: libdevel
Depends:
 libmyth (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libmyth-0.23-0-dev,
 libmyth-0.24-0-dev,
 libmyth-0.25-0-dev,
 libmyth-0.26-0-dev,
 libmyth-0.27-0-dev,
 libmyth-0.28-0-dev,
 libmyth-0.29-0-dev,
 libmyth-29-0-dev,
Replaces:
 libmyth-0.23-0-dev,
 libmyth-0.24-0-dev,
 libmyth-0.25-0-dev,
 libmyth-0.26-0-dev,
 libmyth-0.27-0-dev,
 libmyth-0.28-0-dev,
 libmyth-0.29-0-dev,
 libmyth-29-0-dev,
Description: Common library code for MythTV and add-on modules (development)
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains files needed for developing applications which use
 libmyth (such as the various add-ons for MythTV)

Package: php-mythtv
Architecture: all
Depends:
 ${misc:Depends},
Description: PHP Bindings for MythTV
 MythTV provides a unified graphical interface for recording and viewing
 television programs. Refer to the mythtv package for more information.
 .
 This package contains files needed for using PHP based applications that
 connect to MythTV backends.

Package: libmythtv-perl
Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

#For our custom rules on all mythtv packages
# get-orig-source
# info
# newest-revision
include debian/mythtv.make

#build goes here
buildroot       := debian/tmp

# Set this to yes for releases
MYTHTV_RELEASE ?= no
ifeq (yes,$(MYTHTV_RELEASE))
MYTHTV_COMPILE_TYPE = release
else
MYTHTV_COMPILE_TYPE = profile
endif

# Use the 'profile' compile type when nostrip or noopt is used
ifneq (,$(filter nostrip noopt,$(DEB_BUILD_OPTIONS)))
MYTHTV_COMPILE_TYPE = profile
endif

## Export QT version explicitely (fixes issues for non x86/arm builders)
export QT_SELECT = 5

#                                      #
# Architecture Independent Build flags #
#                                      #
MYTHTV_CONFIGURE_OPTS +=    --compile-type=$(MYTHTV_COMPILE_TYPE) \
				--prefix=/usr \
				--runprefix=/usr \
				--enable-lirc \
				--enable-audio-alsa \
				--enable-audio-oss \
				--enable-dvb \
				--enable-firewire \
				--enable-joystick-menu \
				--with-bindings=perl \
				--enable-pic \
				--perl-config-opts="INSTALLDIRS=vendor" \
				--enable-libvpx \
				--enable-libmp3lame \
				--enable-libx264 \
				--enable-vdpau

#                                    #
# Architecture dependent build flags #
#                                    #
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq "$(DEB_BUILD_ARCH)" "armhf"
	MYTHTV_CONFIGURE_OPTS += --disable-opengl --disable-vaapi
else ifeq "$(DEB_BUILD_ARCH)" "arm64"
	MYTHTV_CONFIGURE_OPTS += --disable-opengl --disable-vaapi
else ifeq "$(DEB_BUILD_ARCH)" "s390x"
	MYTHTV_CONFIGURE_OPTS += --disable-opengl --disable-vaapi
else ifeq "$(DEB_BUILD_ARCH)" "ppc64el"
	MYTHTV_CONFIGURE_OPTS += --disable-opengl --disable-vaapi
else
	MYTHTV_CONFIGURE_OPTS += --enable-vaapi
endif
ifeq "$(DEB_BUILD_ARCH)" "i386"
	MYTHTV_CONFIGURE_OPTS +=  --cpu=i686 --enable-mmx
endif
ifeq "$(DEB_BUILD_ARCH)" "powerpc"
	MYTHTV_CONFIGURE_OPTS += --enable-altivec --extra-cxxflags="-maltivec"
endif
#ifeq "$(DEB_BUILD_ARCH)" "armhf"
#        MYTHTV_CONFIGURE_OPTS += --extra-cflags="-I/opt/vc/include" --extra-cxxflags="-I/opt/vc/include" --extra-cflags="-I/opt/vc/include/IL" --extra-cxxflags="-I/opt/vc/include/IL" --extra-libs="-L/opt/vc/lib" --extra-cflags="-I/opt/vc/include/interface/vcos/pthreads" --extra-cxxflags="-I/opt/vc/include/interface/vcos/pthreads" --extra-cflags="-I/opt/vc/include/interface/vmcs_host/linux" --extra-cxxflags="-I/opt/vc/include/interface/vmcs_host/linux" --extra-libs="-lEGL"
#endif

#Mythplugins configure opts
MYTHPLUGINS_CONFIGURE_OPTS += --prefix=/usr \
                              --qmake=/usr/bin/qmake \

ifeq "$(DEB_BUILD_ARCH)" "armhf"
	MYTHPLUGINS_CONFIGURE_OPTS += --disable-opengl
endif

#Use moar CPUs for jya
PROCESSORS       ?= $(shell grep -ic ^processor /proc/cpuinfo)
ifeq (0,$(PROCESSORS))
PROCESSORS := 1
endif

#link problem with binutils 2.21 in precise
#and ffmpeg sync from 0.26, libswscale
LDFLAGS:=$(shell DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions" dpkg-buildflags --get LDFLAGS)

# Need a writable home directory for ccache
export HOME=$(CURDIR)/debian/home_$(DEB_BUILD_ARCH)

%:
	dh $@ --parallel --with python3

#Rather than have a configure/build/install phase, combine them all so we can do each part in order
override_dh_auto_configure:
override_dh_auto_install:
	# create the DESCRIBE file that Myth's version.sh will use to get the version
	DEB_VERSION="$(shell dpkg-parsechangelog -S version)" ;\
	GIT_VERSION="$(shell echo $(DEB_VERSION) | sed 's/[0-9]:/v/')" ;\
	GIT_MAJOR="$(shell echo $(DEB_VERSION) | sed -e 's/~ubuntu.*//' -e 's/.*://' -e 's/\..*//')" ;\
	GIT_BRANCH="$(shell echo $(DEB_VERSION) | sed -e 's/~ubuntu.*//' -e 's/.*[~+]//' -e 's/\..*//')" ;\
	if [ "$$GIT_BRANCH" = "fixes" ]; then \
		echo "BRANCH=\"$$GIT_BRANCH/$$GIT_MAJOR\"" > mythtv/DESCRIBE ;\
	else \
		echo "BRANCH=\"$$GIT_BRANCH\"" > mythtv/DESCRIBE ;\
	fi ;\
	echo "SOURCE_VERSION=\"$$GIT_VERSION\"" >> mythtv/DESCRIBE ;\

	cd mythtv && sh version.sh `pwd`

	install -m0755 -d $(CURDIR)/debian/home

	#mythtv
	cd mythtv && ./configure $(MYTHTV_CONFIGURE_OPTS)
	$(MAKE) -j$(PROCESSORS) -C mythtv
	$(MAKE) -C mythtv install INSTALL_ROOT=$(CURDIR)/debian/tmp

	#mythplugins
	cd mythplugins && ./configure $(MYTHPLUGINS_CONFIGURE_OPTS) --mythroot=$(CURDIR)/debian/tmp:$(CURDIR)/debian/libmyth-python
	$(MAKE) -j$(PROCESSORS) -C mythplugins
	for plugin in mytharchive \
	mythgame mythmusic mythnews \
	mythweather mythzoneminder mythbrowser ; do \
		$(MAKE) -C mythplugins/$$plugin install INSTALL_ROOT=$(CURDIR)/debian/$$plugin; \
	done

	#(MythTV) We replace these with shell scripts
	mv debian/tmp/usr/bin/mythfrontend debian/tmp/usr/bin/mythfrontend.real
	mv debian/tmp/usr/bin/mythtv-setup debian/tmp/usr/bin/mythtv-setup.real

override_dh_install:
	dh_install -Xusr/share/mythtv/fonts/Free \
                   -Xusr/share/mythtv/fonts/Purisa \
                   -Xusr/share/mythtv/fonts/texgyrechorus \
                   -Xusr/lib/libmythzmq.la \
                   -Xusr/share/mythtv/fonts/tiresias_gpl3.txt \
                   -XLICENSE \
                   -X.git \
                   -Xscriptaculous \
                   -Xprototype.js \
                   -Xjquery.min.js \
                   --fail-missing

	#(MythTV) Remove license files
	find debian/tmp \( -name "COPYING" -o -name "README.license" \) -delete

override_dh_compress:
	dh_compress -X.pl -X.py

override_dh_fixperms:
	dh_fixperms -X.pl -X.py

	#(All) Make sure python/perl scripts are executable
	find debian/tmp/usr/share -type f \( -iname "*.p[yl]" ! -iname "oauth_api.py" \) -size +1b -exec chmod 755 {} \;
	#(All) Remove execute permission from data files
	find debian/tmp \( -name '*.png' -o -name '*.html' -o -name '*.txt' -o -name '*.jpg' -o -name '*.xml' \) -exec chmod 644 {} +

override_dh_auto_clean:
	[ -f mythtv/config.mak ] && $(MAKE) -C mythtv distclean || true
	[ -f mythplugins/config.pro ] && $(MAKE) -C mythplugins distclean || true
	[ -f mythtv/VERSION.old ] && mv mythtv/VERSION.old mythtv/VERSION || true
	dh_auto_clean
	debconf-updatepo
	rm -rf $(CURDIR)/debian/home

override_dh_installdocs:
	dh_installdocs
	#(MythTV) Remove license files from contrib documentation.
	find debian/mythtv-backend/usr/share/doc/mythtv-backend/contrib \
		-name "COPYING" -delete
	rm -f debian/mythtv-common/usr/share/mythtv/themes/Terra/watermarks/README.license

	#(Myththemes)
	rm -f debian/mythtv-theme-childish/usr/share/mythtv/themes/Childish/COPYING

override_dh_installman:
	debian/generate_manpages.sh
	dh_installman
